
 (* BITMAP.PAS *)

{ a grafikus kperny kzepre
  16 szn bitkp felolvasst vgz modul }

unit bitmap2;
{$F+,O+}
interface

 { 16 szn bitkp megjelentse }
 procedure BMPDisplay(FileName: string;x,y:integer;alap:boolean);
 procedure Screenshot;
 var
  width,height:longint;

  type
   TBitMapHeader = Record { a bitkp fejlce }
      bfType :             word;
      bfSize :             longint;
      bfReserved :         longint;     { 0 }
      bfOffBits :          longint;
      biSize :             longint;
      biWidth :            longint;
      biHeight :           longint;
      biPlanes :           word;        { 1 }
      biBitCount :         word;        {1,4,8,24}
      biCompression :      longint;
      biSizeImage :        longint;     {bjtban}
      biXPelsPerMeter :    longint;
      biYPelsPerMeter :    longint;
      biClrUsed :          longint;
      biClrImportant :     longint;
    end;
  type
  TRGBQuad =  Record  { az RGB-paletta elemei }
              rgbBlue,
              rgbGreen,
              rgbRed,
              rgbReserved : Byte;
              end;
  var
   header:Tbitmapheader;
   RGBQuad : TRGBQuad;
   RGBs:array[0..15] of trgbquad;


implementation
 uses Graph;

 type
 TByteArray = Array[0..50000] of byte;

{----------------------------------------------------}
{ 4-bites szneket tartalmaz .BMP fjl tartalmnak  }
{ megjelentse a kperny kzepn                   }
{----------------------------------------------------}
procedure Display4 (var f : file; BitMapHeader : TBitMapHeader;x,y2:integer;alap:boolean);
var
  i, y: Integer;
  TwoPixel, Black : Byte;
  Line : ^TByteArray;
  number : word;
  fst:FillSettingsType;
  CurrentX, BeginX, BeginY, EndY : Integer;
begin
  {if GetMaxColor < 15 then
   begin
     OutText ('Ez a md nem tmogatja a 4 bites sznek hasznlatt!');
     Exit;
   end;}

  Black := 16;

  { a palettasznek felolvassa }
  for i:= 0 to 15 do
   begin
     BlockRead(f, RGBQuad, SizeOf(RGBQuad));
     if (longint(RGBQuad)=0) then Black := i;
     with RGBQuad do
        SetRGBPalette(i, rgbRed shr 2, rgbGreen shr 2, rgbBlue shr 2);
     SetPalette(i,i);
     RGBs[i]:=RGBQuad;
   end;

   with BitMapHeader do
     begin
       { a kpsor bjtok szma }
       Number := (biWidth div 2 + 3) and not 3;
       { kzpre helyezi a kpernyn }
       BeginX := x;
       BeginY := y2+biheight-1;
       EndY   := BeginY+1-biheight;
     end;

  { a kp bitjeinek feldolgozsa }
  GetMem (Line, number + 1);
  { soronknt }
  if alap then
  begin
   GetFillSettings(fst);
   SetFillStyle(1,black);
   Bar(x,y2,x+bitmapheader.biwidth-1,y2+bitmapheader.biheight-1);
   SetFillStyle(fst.pattern,fst.color);
  end;
  for y:=BeginY downto EndY do
    begin
      BlockRead(f, Line^[1], number);
      CurrentX := BeginX;
      { bjtonknt }
      for i:=1 to number do
        begin
          TwoPixel := Line^[i]; { kt kppont }
          if (TwoPixel shr 4<>black) then
         	 PutPixel(CurrentX, y ,TwoPixel shr 4);
          Inc(CurrentX);
          if (TwoPixel and 15<>black) then
        	  PutPixel(CurrentX, y, TwoPixel and 15);
          Inc(CurrentX);
        end;
    end;
  FreeMem (Line, number+1);
end;

procedure NotDisplay(colors:byte);
 var
   tst : string[4];
 begin
   str(colors, tst);
   OutText (tst+' bites szneket tartalmaz bitkp megjelentsre nem alkalmas!');
 end;


{--------------------------------------------}
{ A megadott nev .BMP llomny feldolgozsa }
{--------------------------------------------}
procedure BMPDisplay;
var f: file;
    BitMapHeader : TBitMapHeader;
begin
  Assign(f,FileName);
  FileMode := 0; {Read Only}
  {$I-}
  Reset(f,1);
  FileMode := 2; {Default}
  {$I+}
  if IOResult<>0 then
   begin
    OutText ('A(z) '+FileName+' nev fjl nem ltezik!');
    Exit;
   end;

  { a bitkpfejlc beolvassa }
  BlockRead(f, BitMapHeader, SizeOf(BitMapHeader));
  header:=BitmapHeader;
  width:=header.biwidth;
  height:=header.biheight;
  with BitMapHeader do
    begin
      if (bfType<>19778) or (bfReserved<>0) or (biPlanes<>1) then
        begin
          OutText ('Nem Windows bitkp llomny!');
          Close(f);
          Exit;
        end;
      if biCompression<>0 then
        begin
          OutText ('Nem tud megjelenteni tmrtett llomnyt!');
          Close(f);
          Exit;
        end;
      case biBitCount of
         1  : NotDisplay(1);  {  1-bites szn: ? }
         4  : Display4(f, BitMapHeader,x,y,alap);{ 4-bites szn }
         8  : NotDisplay(8);  {  8-bites szn: ? }
         24 : NotDisplay(24); { 24-bites szn: ? }
         else
            begin
              OutText ('Nem Windows bitkp llomny!');
              Close(f);
              Exit;
            end;
      end;
    end;
  Close(f);
end;
{----------------------------------------------------}
{ screenshot ksztse  }
{----------------------------------------------------}
procedure MakeShot (var f : file; BitMapHeader : TBitMapHeader);
var
  i, y: Integer;
  RGBQuad : TRGBQuad;
  TwoPixel, Black : Byte;
  Line : ^TByteArray;
  number : word;
  fst:FillSettingsType;
  CurrentX, BeginX, BeginY, EndY : Integer;
begin
  if GetMaxColor < 15 then
   begin
     OutText ('Ez a md nem tmogatja a 4 bites sznek hasznlatt!');
     Exit;
   end;

  Black := 16;

  { a palettasznek felolvassa }
  for i:= 0 to 15 do
   begin
     BlockWrite(f, RGBs[i], SizeOf(RGBs[i]));
   end;

   with BitMapHeader do
     begin
       { a kpsor bjtok szma }
       Number := (biWidth div 2 + 3) and not 3;
       { kzpre helyezi a kpernyn }
       BeginX := 0;
       BeginY := 0+biheight-1;
       EndY   := BeginY+1-biheight;
     end;

  { a kp bitjeinek feldolgozsa }
  GetMem (Line, number + 1);
  { soronknt }
  for y:=BeginY downto EndY do
    begin
      CurrentX := BeginX;
      { bjtonknt }
      for i:=1 to number do
        begin
          TwoPixel:=0;
          TwoPixel:=GetPixel(CurrentX,y)*16;
          Inc(CurrentX);
          TwoPixel:=TwoPixel+GetPixel(CurrentX,y);
          Inc(CurrentX);
          Line^[i]:=TwoPixel;
        end;
      BlockWrite(f, Line^, number);
    end;
  FreeMem (Line, number+1);
end;
{--------------------------------------------}
{ Screenshot ksztse a 16 szn kpernyrl }
{--------------------------------------------}
procedure ScreenShot;
var f: file;
    BitMapHeader : TBitMapHeader;
begin
  Assign(f,'scrshot.bmp');
  {$I-}
  Rewrite(f,1);
  {$I+}
  	with header do
   begin
   	bftype:=19778;
      bfreserved:=0;
      biplanes:=1;
      bicompression:=0;
      bibitcount:=4;
      BiWidth:=GetMaxX;
      BiHeight:=GetMaxY;
   end;
  BlockWrite(f, Header, SizeOf(Header));
  MakeShot(f,header);
  { a bitkpfejlc beolvassa }
  header:=BitmapHeader;
  width:=header.biwidth;
  height:=header.biheight;
  Close(f);
end;

end.
