(* BITMAP.PAS *)

{ a grafikus kperny kzepre
  16 szn bitkp felolvasst vgz modul }

unit bitmap;
interface

 { 16 szn bitkp megjelentse }
 procedure BMPDisplay(FileName: string);

implementation
 uses Graph;

 type
   TBitMapHeader = Record { a bitkp fejlce }
      bfType :             word;
      bfSize :             longint;
      bfReserved :         longint;     { 0 }
      bfOffBits :          longint;
      biSize :             longint;
      biWidth :            longint;
      biHeight :           longint;
      biPlanes :           word;        { 1 }
      biBitCount :         word;        {1,4,8,24}
      biCompression :      longint;
      biSizeImage :        longint;     {bjtban}
      biXPelsPerMeter :    longint;
      biYPelsPerMeter :    longint;
      biClrUsed :          longint;
      biClrImportant :     longint;
    end;

 TRGBQuad =  Record  { az RGB-paletta elemei }
              rgbBlue,
              rgbGreen,
              rgbRed,
              rgbReserved : Byte;
 end;

 TByteArray = Array[0..50000] of byte;

{----------------------------------------------------}
{ 4-bites szneket tartalmaz .BMP fjl tartalmnak  }
{ megjelentse a kperny kzepn                   }
{----------------------------------------------------}
procedure Display4 (var f : file; BitMapHeader : TBitMapHeader);
var
  i, y: Integer;
  RGBQuad : TRGBQuad;
  TwoPixel, Black : Byte;
  Line : ^TByteArray;
  number : word;
  CurrentX, BeginX, BeginY, EndY : Integer;
begin
  if GetMaxColor < 15 then
   begin
     OutText ('Ez a md nem tmogatja a 4 bites sznek hasznlatt!');
     Exit;
   end;

  Black := 16;

  { a palettasznek felolvassa }
  for i:= 0 to 15 do
   begin
     BlockRead(f, RGBQuad, SizeOf(RGBQuad));
     if (longint(RGBQuad)=0) then Black := i;
     with RGBQuad do
        SetRGBPalette(i, rgbRed shr 2, rgbGreen shr 2, rgbBlue shr 2);
     SetPalette(i,i);
   end;

   { a bitkp kzpre igaztsa }
   with BitMapHeader do
     begin
       { a kpsor bjtok szma }
       Number := (biWidth div 2 + 3) and not 3;
       { kzpre helyezi a kpernyn }
       BeginX := (GetMaxX - biWidth) div 2;
       BeginY := GetMaxY - (GetMaxY - biHeight) div 2;
       EndY   := BeginY + 1 - biHeight;
     end;

  { a kp bitjeinek feldolgozsa }
  GetMem (Line, number + 1);
  { soronknt }
  for y:=BeginY downto EndY do
    begin
      BlockRead(f, Line^[1], number);
      CurrentX := BeginX;
      { bjtonknt }
      for i:=1 to number do
        begin
          TwoPixel := Line^[i]; { kt kppont }
          if TwoPixel shr 4 <> Black then  { a fels }
             PutPixel(CurrentX, y ,TwoPixel shr 4);
          Inc(CurrentX);
          if TwoPixel and 15 <> Black then  { az als }
             PutPixel(CurrentX, y, TwoPixel and 15);
          Inc(CurrentX);
        end;
    end;
  FreeMem (Line, number+1);
end;

procedure NotDisplay(colors:byte);
 var
   tst : string[4];
 begin
   str(colors, tst);
   OutText (tst+' bites szneket tartalmaz bitkp megjelentsre nem alkalmas!');
 end;


{--------------------------------------------}
{ A megadott nev .BMP llomny feldolgozsa }
{--------------------------------------------}
procedure BMPDisplay(FileName: string);
var f: file;
    BitMapHeader : TBitMapHeader;
begin
  Assign(f,FileName);
  FileMode := 0; {Read Only}
  {$I-}
  Reset(f,1);
  FileMode := 2; {Default}
  {$I+}
  if IOResult<>0 then
   begin
    OutText ('A(z) '+FileName+' nev fjl nem ltezik!');
    Exit;
   end;

  { a bitkpfejlc beolvassa }
  BlockRead(f, BitMapHeader, SizeOf(BitMapHeader));
  with BitMapHeader do
    begin
      if (bfType<>19778) or (bfReserved<>0) or (biPlanes<>1) then
        begin
          OutText ('Nem Windows bitkp llomny!');
          Close(f);
          Exit;
        end;
      if biCompression<>0 then
        begin
          OutText ('Nem tud megjelenteni tmrtett llomnyt!');
          Close(f);
          Exit;
        end;
      ClearDevice;
      case biBitCount of
         1  : NotDisplay(1);  {  1-bites szn: ? }
         4  : Display4(f, BitMapHeader);{ 4-bites szn }
         8  : NotDisplay(8);  {  8-bites szn: ? }
         24 : NotDisplay(24); { 24-bites szn: ? }
         else
            begin
              OutText ('Nem Windows bitkp llomny!');
              Close(f);
              Exit;
            end;
      end;
    end;
  Close(f);
end;

end.
