(* ebreszto.pas *)

{ }
{    pldaprogram a turbo pascal 7.0 s az assembly  nyelv     }
{                          kapcsolatra                        }
{                                                              }
{    Hasznlat: EBRESZTO raperc, pl.: EBRESZTO 2245           }
{                                                              }
{    A program tbb pldnyban is betehet a memriba         }
{    klmbz idpontokkal!                                   }
{  }

program Ebreszto;
{$m 1024, 0, 0}
{$s-,i-,r-,n-,e-,l-,d-}
uses dos;

const
    tick_per_perc = 1092;
    perc_per_ora  = 60;
    ding = 440;    { az a hang}
    dong = 392;    { a  g hang}

    chk_time : boolean = true;

var
    segtsrstack, offtsrstack : word;  { a pascal program stack-je       }
    segappstack, offappstack : word;  { a megszaktott program stack-je }
    alarm_tick, perc, ora    : longint;
    sv                       : integer;
    old_timer                : pointer;


{ *** call_int - megszakts hvst szimull eljrs *** }
{  }
procedure call_int( vector : pointer ); assembler;
 asm
    pushf
    cli
    call dword ptr [bp+4]
  end;

{ *** nosound - a hanggenerls lelltsa *** }
{  }
procedure nosound; assembler;
  asm
     in      al,61h       { a hang tiltsa                  }
     and     al,0fch
     out     61h,al
  end;

{ *** sound - adott frekvencij hang generlsa *** }
{  }
procedure sound(freq:word); assembler;
  asm
     mov     bx,freq      { a timer szmra szksges oszt }
     mov     ax,34ddh     { rtknek meghatrozsa.        }
     mov     dx,12h
     div     bx
     mov     ax,bx
     mov     al,0b6h      { a timer felprogramozsa         }
     out     43h,al
     mov     al,bl
     out     42h,al
     mov     al,bh
     out     42h,al
     in      al,61h       { a hang engedlyezse            }
     or      al,3
     out     61h,al
   end;


{ *** ega_keret - az ega/vga keret villogtatsa *** }
{  }
procedure ega_keret;
var i:byte;
begin
  for i:=0 to 16 do
   asm
     mov ah,10h           { a 10h megszakts 10h funkcijnak }
     mov al,1             { 1. alfunkcija                     }
     mov bh,i
     and bh,0fh
     int 10h
     mov cx,8000h         { vrakozs a szncsere kztt       }
     @var:
     loop @var
   end;
end;



{ *** new_timer - az j 1ch megszaktst kezel rutin *** }
{  }
procedure new_timer; interrupt;
begin
    { az eredeti 1ch megszakts meghvsa }
    call_int( old_timer );

    { az bresztsi id bekvetkezsenek vizsglata }
    if (chk_time) and (meml[$40:$6c] > alarm_tick) then
        begin
        { a chk_time jelzi az breszts megtrtnst }
        chk_time := false;

        { a megszaktott program stack-jnek elmentse , s a ss:sp
          rlltsa a pascal program stack-jre. (a $s- szksges) }
        asm
            cli
            mov offappstack, sp { stack mentse    }
            mov segappstack, ss
            mov sp, offtsrstack { stack belltsa }
            mov ss, segtsrstack
            sti
        end;

        { a tsr programrsz - jelen esetben az breszts - vgrehajtsa }
        for sv:=1 to 10 do
          begin
            sound( ding );
            ega_keret;
            sound( dong );
            ega_keret;
          end;
          nosound;

        { a megszaktott program stack-jnek visszalltsa }
        asm
            cli
            mov  sp, offappstack
            mov  ss, segappstack
            sti
        end;
       end;
end;

{ *** a fprogram *** }
{  }
begin
    { a pascal program stack-jnek elmentse }
        asm
           mov  offtsrstack, sp
           mov  segtsrstack, ss
        end;

    { a parancssor paramterek ellenrzse }
    if (paramcount <> 1) then
        begin
        sound( ding );
        ega_keret;
        nosound;
        writeln( 'hasznlat: ebreszto pp ' );
        halt( 1 );
        end;

    { a paramterknt megadott idpont tick-k val konvertlsa }
    val( paramstr( 1 ), perc, sv );
    perc := perc mod 100;
    val( paramstr( 1 ), ora, sv );
    perc := perc + ((ora div 100) * perc_per_ora);
    alarm_tick := perc * tick_per_perc;

    { ha az idpont mr elmlt nem aktivizldik }
    if (meml[$40:$6c] > alarm_tick) then
        begin
        sound( dong );
        ega_keret;
        nosound;
        writeln( 'a megadott idpont mr elmlt.' );
        halt( 1 );
        end;

    { a megszakts vektor tdefinilsa }
    getintvec( $1c, old_timer );
    setintvec( $1c, @new_timer );

    { rezidens kilps a pascal programbl }
    keep( 0 );
end.

