(* MandPas.pas *)

{--------------------------------------------------------
  Egyszer Mandelbrot halmaz rajzolsa Pascal programmal
  A rajzols ideje mag=1 mellett:

  100 MHz IBM AT (Pentium) s VGA :  19.8 mp
 --------------------------------------------------------}

{  $N+,E- 80x87    }
{  $N+,E+ emultor }

program Mandel;
{$N+,E-,R-,S-}
{$D-,L-}

uses crt,graph;

type
   extended=real;

var
  graphdriver, graphmode:integer;

  restep, imstep : extended;  { a vals s a kpzetes rsz lpshossza }
  repart, impart : extended;              { a vals s a kpzetes rsz }
  x,y            : integer;             { aktulis kpernykoordintk }
  xasp, yasp     : word;                                { aspect ratio }
  maxx, maxy, maxc, cstep : integer;              { grafikai jellemzk }
  color : integer;

const
   restart = -2.267;  reend=1.0;         { a vals rsz rtkhatrai   }
   imstart = -1.12;                     { a kpzetes rsz kezdrtke }
   max : integer = 160;                  { maximlis itercis mlysg }
   mag = 1;                              { magnifikcis tnyez       }

                                    { fggvny az iterci elvgzsre }
function  iterate(re,im : extended): integer;
var
   x,y,x2,y2 : extended;
   k: integer;
begin
  x:=0; y:=0; x2:=y; y2:=0; k:=0;
  repeat
    y:=2*x*y+im;
    x:=x2-y2+re;
    x2:=sqr(x);
    y2:=sqr(y);
    inc(k);
  until (x2+y2 > 4) or (k>=max);
  iterate:=k;
end;

                            { fggvny a kr/ciklois teszt elvgzsre }
function cycltest(zsx,re,im:extended):boolean;
var zr,zs,imq:extended;
begin
  imq := sqr(im);
  zr:={sqr(re) + imq}sqr(re)+imq;
  zs:=sqrt(zr-0.5*re+zsx);
  if (16.0*zr*zs > 5*zs-4*re+1) and
      (sqr(re+1)+imq>zsx)  then cycltest:=true
                                   else cycltest:=false;
end;

begin
  graphdriver:=detect;
  initgraph(graphdriver, graphmode,'');
  getaspectratio(xasp, yasp);
  maxx:=getmaxx;
  maxy:=getmaxy;
  maxc:=maxcolors+1; cstep:=max div (maxc);
  restep:=(reend-restart) /maxx;
  imstep:=restep * yasp / xasp;

  y:=0;
  impart:=imstart;
  while y<=maxy do
  begin
    repart := restart;
    x:=0;
    while x<=maxx do
    begin
      if cycltest(0.0625,repart,impart)
         then color:=iterate(repart,impart)
         else color:=max;
      putpixel(x,y,maxc*cstep-color);
      inc(x,mag);
      repart:=repart+restep*mag;
    end; { while x }
    if keypressed then    { billentynyomssal brmikor ki lehet lpni }
       begin
         readln;
         closegraph;
         exit;
       end;
    inc(y,mag);
    impart:=impart+imstep*mag;

  end;  {while y}
  readln;
  closegraph;
end.

