(* grhanoi2.pas *)
{$R+,S+}
program GrHanoi;
Uses Graph,crt;

const
   MaxKorong = 10;
   L : array [1..10] of byte = (140,128,116,104,92,80,68,56,44,32);

 type
   Palca       = (bal, kozepso, jobb);
   KorongHatar = integer;
   PalcaTombT = array[Palca,0..MaxKorong] of byte;

 var
   GrDriver, GrMode, Error : integer;
   KorongSzam           : KorongHatar;
   i, Sh, Korong        : integer;
   PalcaTomb            : PalcaTombT;
   DelayTime            : integer;


 procedure PalcaRajz(i : integer);
 var k : integer;
   begin
     k := 200*i;
     line( 35+k, 350, 185+k, 350);
     line(109+k, 100, 109+k, 350);
     line(111+k, 100, 111+k, 350);
   end;

 procedure KorongRajz(Korong, Sh : integer; Lathato : Boolean);
  var
    Center, x1, x2, y1, y2 : integer;
  begin

    if Lathato then Setfillstyle(solidfill, korong)
               else Setfillstyle(solidfill, GetBkColor);

    Center := 110 + Sh*200;
    x1 := Center - L[Korong] div 2;
    x2 := Center + L[Korong] div 2;

    Korong:=PalcaTomb[Palca(sh),0];

    y1 := 350 - Korong *23;
    y2 := 350 - (Korong-1)*23-1;

    bar(x1,y1,x2,y2);

    if not lathato then
     begin
       line(109+sh*200, y2, 109+sh*200, y1);
       line(111+sh*200, y2, 111+sh*200, y1);
     end;
   end;



 procedure Mozgat(N : Koronghatar; Honnan, Seged, Hova : Palca);

   procedure Mozgat_Honnan_Hova;
   begin
    KorongRajz(PalcaTomb[Honnan,PalcaTomb[Honnan,0]], ord(Honnan), FALSE);
    inc(PalcaTomb[Hova,0]);
    PalcaTomb[Hova,PalcaTomb[Hova,0]]:=PalcaTomb[Honnan,PalcaTomb[Honnan,0]];
    dec(PalcaTomb[Honnan,0]);
    KorongRajz(PalcaTomb[Hova,PalcaTomb[Hova,0]], ord(Hova), TRUE);
    delay(DelayTime);
   end  { Mozgat_Honnan_Hova };

   begin
     if N=1 then Mozgat_Honnan_Hova
     else
       begin
         Mozgat(N-1, Honnan, Hova, Seged);
         Mozgat_Honnan_Hova;
         Mozgat(N-1, Seged, Honnan, Hova)
       end
   end   { Mozgat };


 begin
   GrDriver := Detect;
   InitGraph(GrDriver, GrMode, '');
   Error := GraphResult;
   if  Error <> grOk  then
     writeln(GraphErrorMsg(Error))
   else
     begin
       RestoreCRTMode;
       repeat
         writeln;
         write('    Krem a korongok szmt (max. 10) : ');
         readln(KorongSzam);
       until KorongSzam<=10;
       write('    Krem a vrakozsi idt : ');
       readln(DelayTime);
       SetGraphMode(GetGraphMode);

       for i:=0 to 2 do Palcarajz(i);

       for i:=1 to KorongSzam do
           begin
              PalcaTomb[bal,i]:=i;
              PalcaTomb[bal,0]:=i;
              KorongRajz(i, 0, TRUE);
           end;

       PalcaTomb[bal,0]     :=KorongSzam;
       PalcaTomb[kozepso,0] :=0;
       PalcaTomb[jobb,0]    :=0;

       Mozgat(KorongSzam, bal, kozepso, jobb);

     readln;
     CloseGraph
     end
 end.
