(* lineinp *)

Program LineInput;
Uses Crt;

{ ------------------ Konstansok ------------------ }

Const
  BS   =  #8;
  CR   = #13;
  SP   = #32;
  Esc  = #27;

  LeftKey  = #75;     HomeKey = #71;
  RightKey = #77;     EndKey  = #79;
  InsKey   = #82;     DelKey  = #83;

  HunChar   = ['','','','','','','','','','','','',''] ;
  AlphaChar = [' ','a'..'z','A'..'Z'] + HunChar ;
  NumChar   = ['0'..'9'] ;
  HexaChar  = ['A'..'F', 'a'..'f'] + NumChar;
  AllChar   = [#32..#255] ;

{ ------------------ Tpus ------------------ }

Type
   CharSet = Set Of Char;

{ ------------------ GetString ------------------ }

{  Procedure GetString:
   Size    -  az inputsor hossza
   Str     -  a be- s kimen sztring
   Fill    -  kitlt karakter
   ChSet   -  engedlyezett karakterhalmaz
   Use     -  true  : rgi tartalom mdostsa,
              false : j adat bevitele
}
Procedure GetString(Size : Byte ; Var Str: String;
                    Fill : Char; ChSet : Charset; ToUse : Boolean);
  Var
    CurrLen   : Byte absolute Str;
    X, Y,
    CurrPos   : Byte;
    Insert    : Boolean;
    I         : Integer;
    Ch         : Char;

  Begin   {GetString}

    Insert  := False;
    X       := WhereX; {Kezdpozci}
    Y       := WhereY;
    CurrPos := 0; {Az aktulis karakter pozcija}

    If Not ToUse then {j tartalom!}
      Begin
        CurrLen := 0;
        Insert  := True;
      End;

    Repeat
      GotoXY(X,Y);
      Write(Str);
      For I := CurrLen+1 To Size Do Write(Fill); {sorkitlts}
      GotoXY(X+CurrPos,Y);
      Ch := ReadKey;

      If Ch = #0 Then  {vezrlkarakterek: <-, ->, Ins, Home, End, Del}
        Begin   {If}
          Ch := ReadKey;
          Case Ch Of
            LeftKey  : If CurrPos > 0 Then Dec(CurrPos);
            RightKey : If (CurrPos < CurrLen) And
                          (CurrPos < Size) Then Inc(CurrPos);
            InsKey   : Insert := Not Insert;
            HomeKey  : CurrPos := 0;
            EndKey   : CurrPos := CurrLen;
            DelKey   : If CurrLen > CurrPos Then
                         Begin   {If}
                           For I := CurrPos+1 To CurrLen-1 Do
                             Str[I] := Str[I+1];
                           Dec(CurrLen)
                         End    {If}
          End    {Case Ch Of}
        End    {If}
      Else
        Begin   {Else}
          Case Ch Of
            BS       : If CurrPos > 0 Then       {visszatrls}
                         Begin   {If}
                           For I := CurrPos To CurrLen-1 Do
                             Str[i] := Str[i+1];
                           Dec(CurrPos);
                           Dec(CurrLen)
                         End;    {If}
            SP..#255:  If Ch In ChSet Then
                         If CurrLen < Size Then  {karakter hozzadsa}
                           Begin   {If}
                             If insert Then
                               Begin   {If}
                                 For I := CurrLen DownTo CurrPos Do
                                   Str[i+1] := Str[i];
                                 Inc(CurrLen);
                                 Inc(CurrPos);
                                 Str[CurrPos] := Ch;
                               End
                             else
                               if CurrPos<CurrLen then
                                 Begin  {If}
                                  Inc(CurrPos);
                                  Str[CurrPos] := Ch;
                                 End;   {If}
                           End;   {If}
          End;   {Case Ch Of}
        End;   {Else}
    Until (Ch = CR) or (Ch = Esc);
    If Ch = Esc Then
      Halt;
    WriteLn;
  End    {GetString};



{ ------------------ Tesztel fprogram ------------------ }

Type
   TDep = Record
      Name,
      Address,
      Tel,
      Comment : String;
   End;

Var
   Dep     : TDep;
Begin
   Dep.Name    := 'ComputerBooks';
   Dep.Address := '1126 Budapest, Tartsay V. u. 12.';
   Dep.Tel     := '175-15-64';
   TextBackGround(Blue);
   TextColor(15);
   ClrScr;
   GotoXY(1,5);
   With Dep Do
     Begin
        Write('Nv        : ');
        TextColor(7);
        GetString(30 , Name, #$B2,AlphaChar, True);
        TextColor(15);
        Write('Cm        : ');
        TextColor(12);
        GetString(40, Address, '_', ALLChar, True);
        TextColor(15);
        Write('Telefon    : ');
        TextColor(9);
        GetString(10, Tel, '.', Numchar+['-'],True);
        TextColor(15);
        Write('Egyb info : ');
        TextColor(14);
        GetString(20, Comment, #$B2, AlphaChar, False);
        TextColor(15);
     End;

   TextBackGround(Black);
   TextColor(LightGray);
   ClrScr;
   GotoXY(1,5);
   WriteLn(Dep.Name);
   WriteLn(Dep.Address);
   WriteLn(Dep.Tel);
   WriteLn(Dep.Comment);
   WriteLn;
   ReadLn;
End.
