(* bin2asc.pas *)

{ A program a megadott binris llomnyt ASCII fjll
  konvertlja }
program asc2bin;

 const
   sp = 32;

 type
    tharmas = array[0..2] of byte;
    tnegyes = array[0..3] of byte;

 var
    harmasok: array[1..15] of tharmas;
    negyes  : tnegyes;
    fnev    : string[12];
    nok,i,j : integer;
    fbin    : file;
    fasc    : text;

{ Az s sztringet nagybetss alaktja}
function upperstr(s : string) : string;
 var slen : byte absolute s;
     i    : byte;
 begin
   for i := 1 to slen do
      s[i] := upcase(s[i]);
   upperstr := s;
 end;

{ 3*8 bitbl -> 4*6 bit ellltsa }
procedure harmas2negyes(harmas: tharmas; var negyes: tnegyes);
 var i: integer;
 begin
   negyes[0] := (harmas[0] shr 2);
   negyes[1] := ((harmas[0] shl 4) and $30) + ((harmas[1] shr 4) and $0f);
   negyes[2] := ((harmas[1] shl 2) and $3c) + ((harmas[2] shr 6) and $03);
   negyes[3] := (harmas[2] and $3f);
   for i:=0 to 3 do
   begin
     if negyes[i] = 0 then negyes[i] := $40;
     inc(negyes[i],sp) {+32}
   end
 end;

{ a fprogram }
begin

  { ha nincs paramter}
  if paramcount = 0 then
  begin
    writeln('Hasznlat: BIN2ASC binris fjl [ascii fjl]');
    halt
  end;

  { ha a kt paramter megegyezik}
  if upperstr(paramstr(1)) = upperstr(paramstr(2)) then
  begin
    writeln(#7'Hiba: bemeneti fjl = kimeneti fjl');
    halt(1)
  end;

  { a binris llomny megnyitsa }
  assign(fbin, paramstr(1));
  {$I-} reset(fbin, 1); {$I+}
  if ioresult <> 0 then
  begin
    writeln(#7'Hiba: a(z) ',paramstr(1),' llomny nem nyithat meg!');
    halt(2)
  end;

  { ha nincs 2. paramter a kimeneti fjl neve a bemeneti fjl
    neve lesz .ASC kiterjesztssel}
  if paramcount <> 2 then
     begin
       fnev := paramstr(1);
       i := pos('.',fnev);
       if i > 0 then delete(fnev, i, length(fnev));
       fnev := fnev + '.asc'
     end
  else
     fnev := paramstr(2);

  { ha a kt fjlnv megegyezik}
  if upperstr(paramstr(1)) = upperstr(fnev) then
  begin
    writeln(#7'Hiba: bemeneti fjl = kimeneti fjl');
    halt(1)
  end;

  { az ascii llomny ltezsnek ellenrzse }
  assign(fasc, fnev);
  if paramcount > 1 then
  begin
    {$I-} reset(fasc); {$I+}
    if ioresult = 0 then
    begin
      writeln(#7'Hiba: a(z) ',fnev,' llomny mr ltezik!');
      halt(3)
    end
  end;

  { az ascii llomny megnyitsa }
  {$I-} rewrite(fasc); {$I+}
  if ioresult <> 0 then
  begin
    writeln(#7'Hiba: nem sikerlt ltrehozni a(z) ',fnev,' llomnyt!');
    halt(4)
  end;

  { a konverzi elvgzse }

  {fejlc}
  writeln(fasc,'begin 0730 ',paramstr(1));
  repeat
    fillchar(harmasok, sizeof(harmasok),#0);
    blockread(fbin, harmasok, sizeof(harmasok), nok);
    write(fasc, char(sp+nok));   { bjtszm 0..45}
    for i:=1 to (nok+2) div 3 do
     begin
       harmas2negyes(harmasok[i], negyes);
       for j:=0 to 3 do
          write(fasc, char(negyes[j]));   { 6 bites szmok + 32 }
     end;
    writeln(fasc)
  until (nok < sizeof(harmasok));
  writeln(fasc,'end');  {lezrs}

  close(fbin);
  close(fasc);

  writeln('A konvertlt llomny: ',fnev);
  writeln
end.

