(* crc16.pas *)

program crc16;

const   beep  = #7;
type    puf     = array [1..$1000] of byte;
var     puffer  : puf;
        fnev    : string;
        fl      : file;
        nok     : word;
        vcrt16  : integer;

{------------------------------------------------}
{ ktbjtos hexadecimlis retket kir eljrs }
{------------------------------------------------}
 procedure writehex( decertek : integer );
  var ch      : char;
      shft    : byte;
  begin
    if (decertek = 0)
    then
      write('0')
    else
      begin
        shft := 16;
        repeat
          dec( shft, 4 );
          ch := chr( decertek shr shft and $f or ord('0') ); { 0..9 }
          if (ch > '9') then inc( ch, 7 );                   { a..f }
          write( ch );                        { a jegy kirsa }
        until (shft = 0);
      end;
  end;

{ -----------------------------------------------------}
{ Ellenrzsszeg (crc) szmtsa a puffer tartalmbl }
{ -----------------------------------------------------}
 function updatecrc16(    crc   : integer;  { a mdostand 16 bites crc }
                      var inbuf : puf;      { az adatpuffer, s a hossza }
                      puflen    : integer) :integer;

  var bit, pindex : integer;
      carry       : boolean;  { tlcsorduls-jelz }
  begin
    for pindex := 1 to puflen do    { a puffer adatai   }
        for bit := 7 downto 0 do    { az adatok bitjei  }
          begin
              carry := crc and $8000 <> 0;        { 15. bit 1 vagy 0 ? }
              crc := (crc shl 1) or (inbuf[pindex] shr bit) and 1;
              { a tlcsorduls figyelembevtele }
              if carry then crc := crc xor $1021;
          end;
    updatecrc16 := crc;  { az j crc-rtk }
  end;

{-------------}
{ a fprogram }
{-------------}
begin
    { a paramterezs ellenrzse }
    if (paramcount <> 1) then
      begin
        writeln;
        writeln( 'Hasznlat: CRC16 fjlnv', beep );
        halt(2);
      end;

    { fjlnyits }
    fnev := paramstr(1);
    assign( fl, fnev );
    {$i-} reset( fl, 1 ); {$i+}
    if (ioresult <> 0) then
      begin
        writeln;
        writeln( 'A ',fnev,' fjl nem elrhet!', beep );
        halt(3);
      end;

    { a fjltartalom feldolgozsa }
    vcrt16 := 0;
    repeat
      blockread( fl, puffer[1], sizeof(puf), nok );
      vcrt16 := updatecrc16( vcrt16, puffer, nok );
    until (nok <> sizeof(puf)) or eof(fl);
    close( fl );

    { a CRC-szmts lezrsa }
    puffer[1] := 0;
    puffer[2] := 0;
    vcrt16 := updatecrc16( vcrt16, puffer, 2 );

    writeln;
    write( 'A ',fnev,' fjl 16-bites ellenrzsszege: ');
    writehex( vcrt16 );
    writeln;
end.
