(* sortlist.pas *)

program sortlist;

type { a listaelem tpusa }
   tadat = string[132];
   pelem = ^telem;
   telem  = record
      adat : tadat;
      ptr  : pelem;
   end;


{ hiba esetn itt lp ki a program }
procedure halterr(msg:string);
 begin
   writeln(#7,'Futsi hiba :  ',msg);
   writeln(#7,'a program futsa megszakadt.');
   halt(1);
 end;

{ hibajelzs helyett nil pointer }
function HeapFunc(size:word) :integer; far;
 begin
   heapfunc:=1;
 end;


{ j elem beszrsa a listba }
procedure elemfelvetel(var bptr : pelem; const adat0 : tadat);
  var
    sptr, tptr, newptr : pelem;
  begin
    { helyfoglals az j elem szmra }
    new(newptr);
    if not assigned(newptr) then halterr('Nincs elg memria');
    newptr^.adat:= adat0;

    { els elem }
    if bptr=nil then
     begin
       bptr:=newptr;
       bptr^.ptr:=nil;
       exit;
     end;

    { ha az j adat <= az els elemnl, akkor beszrjuk az
      els elem el }
    if (adat0 <= bptr^.adat)  then
                  begin
                    newptr^.ptr:=bptr;
                    bptr:=newptr;
                    exit;
                  end;

    { Megkeressk, hogy melyik kt elem kz esik az adat0 }
    { ellenrizzk a nla bagyobbat, vagy a lista vgt }
    sptr:=bptr;           { els }
    tptr:=bptr^.ptr;      { msodik }
    while (tptr <> nil) and (tptr^.adat<=adat0) do
    begin
      sptr:=tptr;          { tovbblp }
      tptr:=tptr^.ptr;
    end;

   { mivel nincs az adat0-nl nagyobb elem, a lista vgre tesszk
     az j elemet }
   if (tptr=nil) and (sptr^.adat<=adat0) then
     begin
       sptr^.ptr:=newptr;
       newptr^.ptr:=nil;
       exit;
     end;

   { ha az utols elem nagyom az adat0-nl }
   if (tptr=nil) and (sptr^.adat>adat0) then
   begin
     tptr:=sptr;
     sptr:=bptr;
     { megkeressk az utols eltt ll elemet }
     while sptr^.ptr<>tptr do
        sptr:=sptr^.ptr;
   end;

   { az sptr^ s a tptr^ kz szrjuk be az j elemet}
   newptr^.ptr:=tptr;
   sptr^.ptr:=newptr;
  end;

var
  begptr, sptr, tptr : pelem;
  sor  : integer;
  adat : tadat;
  tf   : text;

{ fprogram}
begin
  HeapError:=@HeapFunc;

  { A paramterezs tesztelse }
  if not (paramcount in [1,2]) then
    halterr(#13+#10+#13+#10+'Hasznlat: SORTLIST bellomny [killomny]'+ #13+#10);

  { Az inputfjl megnyitsa}
  assign(tf, paramstr(1));
  {$I-}
  reset(tf);
  {$I+}
  if ioresult<>0 then
     halterr('nem elrhet fjl: '+paramstr(1));

  writeln('A(z) ', paramstr(1), ' llomny megnyitsa sikeres volt.');
  writeln('A lista felptse folyamatban ...');
  sor:=0;
  { a sztringlista felptse, a bptr a lista elejre mutat}
  begptr:=nil;
  while not eof(tf) do
    begin
      readln(tf, adat);
      inc(sor);
      elemfelvetel(begptr, adat);
    end;
   close(tf);

   writeln('A lista ksz van!');
   writeln('A beolvasott sorok szma: ', sor:5);
   writeln;
   writeln ('A kirshoz nyomja meg az <Enter> billentyt!');
   readln;

  { Az outputfjl megnyitsa}
  if paramstr(2)='' then assign(tf, 'CON')
                    else assign(tf, paramstr(2));
  {$I-}
  rewrite(tf);
  {$I+}
  if ioresult<>0 then
     halterr('nem elrhet fjl: '+paramstr(2));

  writeln('A(z) ', paramstr(2), ' llomny megnyitsa sikeres volt.');
  writeln('A kirs folyamatban ...');

  { a lista vgigjrsa az elemek kiratsval }
  sptr:=begptr;
  repeat
    writeln(tf,sptr^.adat);
    sptr := sptr^.ptr;
  until sptr=nil;
  close(tf);
   writeln('A kirs befejezdtt!');

  { a lista felszabadtsa }
  sptr:=begptr;
  repeat
    tptr := sptr^.ptr; { a kvetkez elem }
    dispose(sptr);     { az aktulis felszabadtsa }
    sptr := tptr;      { tovbblp }
  until sptr=nil;

end.