(* MTERVEZO.PAS  *)

{-----------------------------------------------------------------
 Interaktv egrkurzor tervez program
 -----------------------------------------------------------------}

program MOUSE_TERVEZO;

uses Crt,  Graph,  OOPMouse;

const grafdriver = ega;
      grafmode   = egahi;
type
   Str20 = string[20];

var
   GMouse    : GraphicMouse;
   TMouse    : TextMouse;
   mButton   : Position;
   NewCursor : gCursor;
   GDriver, GMode, GError, i, j, Buttons,
      XIndex, YIndex, HotSpotX,  HotSpotY : integer;
   Exit, HotSpotSelect, MStatus : Boolean;
   outline : array[1..5] of pointtype;
   Screen, Cursor : array[0..15,0..15] of Boolean;
   Ch : char;


{-----------------------------------------------------------------}
{                  Keretezett szvegkirs                        }
{-----------------------------------------------------------------}

procedure BoxItem( x, y, w, h : integer; text : str20 );
   begin
      SetTextJustify( CenterText, CenterText );
      Rectangle( x, y, x+w, y+h );
      OutTextXY( x+(w div 2), y+(h div 2), text );
   end;

{-----------------------------------------------------------------}
{                  Fillezett ngyzet rajzolsa                    }
{-----------------------------------------------------------------}

procedure FillSquare( x1, y1, x2, y2,
                     FillStyle, Color : integer );
   var
      outline : array[1..5] of pointType;
   begin
      outline[1].x := x1;  outline[1].y := y1;
      outline[2].x := x2;  outline[2].y := y1;
      outline[3].x := x2;  outline[3].y := y2;
      outline[4].x := x1;  outline[4].y := y2;
      outline[5] := outline[1];
      SetFillStyle( FillStyle, Color );
      FillPoly( sizeof( outline ) div
                sizeof( PointType ), outline );
   end;

{-----------------------------------------------------------------}
{                           Ngyzet trlse                       }
{-----------------------------------------------------------------}

procedure EraseSquare( x1, y1, x2, y2 : integer );
   var
      i, j : integer;
   begin
      FillSquare( x1, y1, x2, y2, SolidFill, BLACK );
   end;

{-----------------------------------------------------------------}
{                           Hangjelzs                            }
{-----------------------------------------------------------------}

procedure Beep;
   begin
      Sound( 220 ); delay( 100 ); NoSound;
                    delay(  50 );
      Sound( 440 ); delay( 100 ); NoSound;
   end;

{-----------------------------------------------------------------}
{                    Sztring -> hexa konverzi                    }
{-----------------------------------------------------------------}

function StrToHex( WorkStr: string ): word;
   var
      TempVal : word;
   begin
      TempVal := $0000;
      for i := 1 to length(WorkStr) do
      begin
         TempVal := TempVal shl 4;
         case WorkStr[i] of
            '1' : inc(TempVal, 1);
            '2' : inc(TempVal, 2);
            '3' : inc(TempVal, 3);
            '4' : inc(TempVal, 4);
            '5' : inc(TempVal, 5);
            '6' : inc(TempVal, 6);
            '7' : inc(TempVal, 7);
            '8' : inc(TempVal, 8);
            '9' : inc(TempVal, 9);
            'A' : inc(TempVal,10);
            'B' : inc(TempVal,11);
            'C' : inc(TempVal,12);
            'D' : inc(TempVal,13);
            'E' : inc(TempVal,14);
            'F' : inc(TempVal,15);
         end; {case}
      end;
      StrToHex := TempVal;
   end;

{-----------------------------------------------------------------}
{                    Hexa -> sztring konverzi                    }
{-----------------------------------------------------------------}

function HexToStr( NumVal : word ): string;
   var
      Temp : string[4];
      CVal : byte;
         i : integer;
   begin
      Temp :='';
      for i := 1 to 4 do
      begin
         CVal := NumVal and $000f;
         NumVal := NumVal shr 4;
         case CVal of
            0 : Temp := '0' + Temp;
            1 : Temp := '1' + Temp;
            2 : Temp := '2' + Temp;
            3 : Temp := '3' + Temp;
            4 : Temp := '4' + Temp;
            5 : Temp := '5' + Temp;
            6 : Temp := '6' + Temp;
            7 : Temp := '7' + Temp;
            8 : Temp := '8' + Temp;
            9 : Temp := '9' + Temp;
           10 : Temp := 'A' + Temp;
           11 : Temp := 'B' + Temp;
           12 : Temp := 'C' + Temp;
           13 : Temp := 'D' + Temp;
           14 : Temp := 'E' + Temp;
           15 : Temp := 'F' + Temp;
         end; {case}
      end;
      HexToStr := Temp;
   end;

{-----------------------------------------------------------------}
{                    Egr-kurzor generls                        }
{-----------------------------------------------------------------}

procedure MakeCursor;
   var
      i, j : integer;
      TBit : word;
   begin
      with NewCursor do
      begin
         hotX := HotSpotX;
         hotY := HotSpotY;
         for i := 0 to 15 do
         begin
            ScreenMask[i] := $0000;
            CursorMask[i] := $0000;
         end;
         for i := 0 to 15 do
         begin
            TBit := $0001;
            for j := 0 to 15 do
            begin
               CursorMask[i] := CursorMask[i] shl 1;
               if Cursor[j,i] then inc(CursorMask[i]);
               ScreenMask[i] := ScreenMask[i] shl 1;
               if Screen[j,i] then inc(ScreenMask[i]);
            end;
         end;
      end;
   end;

{-----------------------------------------------------------------}
{                    Az j kurzor hasznlata                      }
{-----------------------------------------------------------------}

procedure UseNewCursor;
   begin
      MakeCursor;
      GMouse.Show( FALSE );
      GMouse.SetCursor( NewCursor );
      GMouse.Show( TRUE );
   end;

{-----------------------------------------------------------------}
{                   A Screen maszk megjelentse                  }
{-----------------------------------------------------------------}

procedure PaintScreen( X, Y : integer );
   var
      Color : integer;
   begin
      if ( X = HotSpotX ) and ( Y = HotSpotY )
         then Color := lightred
         else Color := WHITE;
      GMouse.Show( FALSE );
      if Screen[X,Y] then
         FillSquare( (X+1) * 15 + 3, (Y+2) * 15 + 3,
                     (X+2) * 15 - 3, (Y+3) * 15 - 3,
                     SolidFill, Color )
      else
         FillSquare( (X+1) * 15, (Y+2) * 15,
                     (X+2) * 15, (Y+3) * 15,
                     CloseDotFill, Color );
      GMouse.Show( TRUE );
      SetColor( WHITE );
   end;

{-----------------------------------------------------------------}
{                   A Kurzor maszk megjelentse                  }
{-----------------------------------------------------------------}

procedure PaintCursor( X, Y : integer );
   var
      Color : integer;
   begin
      if ( X = HotSpotX ) and ( Y = HotSpotY )
         then Color := lightred
         else Color := WHITE;
      GMouse.Show( FALSE );
      if Cursor[X,Y] then
         FillSquare( (X+1) * 15 + 369, (Y+2) * 15,
                     (X+2) * 15 + 366, (Y+3) * 15 - 3,
                     SolidFill, Color )
      else
         FillSquare( (X+1) * 15 + 369, (Y+2) * 15,
                     (X+2) * 15 + 369, (Y+3) * 15,
                     WideDotFill, Color );
      GMouse.Show( TRUE );
      SetColor( WHITE );
   end;

{-----------------------------------------------------------------}
{               Egr-kurzor clpont kirajzolsa                   }
{-----------------------------------------------------------------}

procedure HotSpotComplete;
   var
      X, Y :integer;
   begin
      X := HotSpotX;
      Y := HotSpotY;
      PaintCursor( X, Y );
      PaintScreen( X, Y );
      Gmouse.Show( FALSE );
      HotSpotSelect := FALSE;
      SetColor( WHITE );
      SetTextJustify( CenterText, CenterText );
      boxItem(   279, 250, 80, 20, 'Clpont' );
      Gmouse.Show( TRUE );
   end;

{-----------------------------------------------------------------}
{               Egr-kurzor clpont belltsa                    }
{-----------------------------------------------------------------}

procedure SetHotSpot;
   var
      X, Y : integer;
   begin
      X := HotSpotX;
      Y := HotSpotY;
      HotSpotX := -1;
      HotSpotY := -1;
      PaintCursor( X, Y );
      PaintScreen( X, Y );
      GMouse.Show( FALSE );
      HotSpotSelect := TRUE;
      SetColor( lightred);
      SetTextJustify( CenterText, CenterText );
      BoxItem(   279, 250, 80, 20, 'Clpont' );
      SetColor( WHITE );
      GMouse.Show( TRUE );
   end;

{-----------------------------------------------------------------}
{                        A kperny generlsa                    }
{-----------------------------------------------------------------}

procedure ScreenLayout;
   var
      j : integer;
   begin
      j := GetMaxX;
      SetTextJustify( CenterText, CenterText );
      OutTextXY( 135, 20, 'Screen maszk' );
      OutTextXY( 504, 20, 'Kurzor maszk' );
      HotSpotComplete;
      BoxItem(  15, 280,  60, 20, 'Trls');
      BoxItem(  85, 280,  60, 20, 'Inverz' );
      BoxItem( 155, 280, 140, 20, 'Screen generls' );
      BoxItem( 564, 280,  60, 20, 'Trls' );
      BoxItem( 494, 280,  60, 20, 'Inverz' );
      BoxItem( 344, 280, 140, 20, 'Kurzor -> Screen' );
      BoxItem(  15, 320, 110, 20, 'Kurzor teszt' );
      BoxItem( 140, 320, 110, 20, 'Nyl kurzor' );
      BoxItem( 265, 320, 110, 20, 'Kurzort tlt');
      BoxItem( 390, 320, 110, 20, 'Kurzort ment');
      BoxItem( 515, 320, 110, 20, 'Kilp' );
      Setfillstyle(Solidfill,white);
      Bar( 279, 120, 279+80,120+50);
   end;

{-----------------------------------------------------------------}
{                       A screen maszk trlse                    }
{-----------------------------------------------------------------}

procedure ClearScreen;
   var
      i, j : integer;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
            if Screen[i,j] then
            begin
               Screen[i,j] := FALSE;
               PaintScreen( i, j );
   end;     end;

{-----------------------------------------------------------------}
{                       A kurzor maszk trlse                    }
{-----------------------------------------------------------------}

procedure ClearCursor;
   var
      i, j : integer;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
            if Cursor[i,j] then
            begin
               Cursor[i,j] := FALSE;
               PaintCursor( i, j );
   end;     end;

{-----------------------------------------------------------------}
{                     A screen maszk invertlsa                  }
{-----------------------------------------------------------------}

procedure InvertScreen;
   var
      i, j : integer;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
         begin
            Screen[i,j] := not Screen[i,j];
            PaintScreen( i, j );
   end;  end;

{-----------------------------------------------------------------}
{                     A kurzor maszk invertlsa                  }
{-----------------------------------------------------------------}

procedure InvertCursor;
   var
      i, j : integer;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
         begin
            Cursor[i,j] := not Cursor[i,j];
            PaintCursor( i, j );
   end;  end;

{-----------------------------------------------------------------}
{                 Pont kitevs a screen maszkon                   }
{-----------------------------------------------------------------}

procedure ScreenSet( mButton : Position );
   var
      x, y : integer;
   begin
      x := mButton.xPos div 15 - 1;
      y := mButton.yPos div 15 - 2;
      if HotSpotSelect then
      begin
         HotSpotX := x;
         HotSpotY := y;
         HotSpotComplete;
      end else
      begin
         Screen[x,y] := not Screen[x,y];
         PaintScreen( x, y );
      end;
   end;

{-----------------------------------------------------------------}
{                 Pont kitevs a kurzor maszkon                   }
{-----------------------------------------------------------------}

procedure CursorSet( mButton : Position );
   var
      x, y : integer;
   begin
      x := ( mButton.xPos - 384 ) div 15;
      y := ( mButton.yPos div 15) -2;
      if HotSpotSelect then
      begin
         HotSpotX := x;
         HotSpotY := y;
         HotSpotComplete;
      end else Cursor[x,y] := not Cursor[x,y];
      PaintCursor( x, y );
   end;

{-----------------------------------------------------------------}
{          A kurzor maszk tmsolsa a screen maszkba             }
{-----------------------------------------------------------------}

procedure CursorToScreen;
   var
      i, j : integer;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
         begin
            Screen[i,j] := Cursor[i,j];
            PaintScreen( i, j );
   end;  end;

{-----------------------------------------------------------------}
{          Screen maszk generlsa a kurzor maszkbl              }
{-----------------------------------------------------------------}

procedure ScreenFromCursor;
   var
      i, j, x, y : integer;
      Test : boolean;
   begin
      for i := 0 to 15 do
         for j := 0 to 15 do
         begin
            Test := TRUE;
            for x := -1 to 1 do
               for y := -1 to 1 do
                  if( i + x in [0..15] ) and
                    ( j + y in [0..15] ) and
                      Cursor[ i + x, j + y] then
                         Test := FALSE;
              Screen[ i , j ] := Test;
              PaintScreen( i, j );
   end;   end;

{-----------------------------------------------------------------}
{          Az egr-kurzor definicijnak file-ba mentse          }
{-----------------------------------------------------------------}

procedure SavePointer;
   var
      i, j, k : integer;
      Ch : char;
      CF : text;
      Done : Boolean;
      FileName : string[12];
   begin
      i := 0;
      Done := FALSE;
      FileName := '........';
      SetViewPort( 269, 0, 369, 42, TRUE );
      SetTextJustify( CenterText, CenterText );
      GMouse.setCursor( ibeam );
      repeat
         inc(i);
         GMouse.Show( FALSE );
         ClearViewPort;
         SetColor( white);
         Rectangle( 0, 0, 100, 40 );
         OutTextXY( 50, 10, 'Kiments');
         OutTextXY( 50, 20, 'File-nv ?' );
         OutTextXY( 50, 30, FileName);
         GMouse.Show( TRUE );
         GMouse.SetPosition( 284+i*8,30 );
         repeat until KeyPressed;
         Ch := ReadKey;
         case Ch of
               #0   : begin Ch:=Readkey; dec(i,1); end;
               #$0D : Done := TRUE;
               #$08 : if( i > 1 ) then dec( i,2 );
            '0'..'9',
                 ' ',
            'A'..'Z',
            'a'..'z': if( i > 8 ) then
                      begin
                         Beep;
                         dec(i,1);
                  end else FileName[i] := UpCase(Ch)
            else dec(i,1);
         end; {case}
      until Done;
      GMouse.SetCursor( arrow );
      GMouse.Show( FALSE );
      ClearViewPort;
      GMouse.Show( TRUE );
      for i := 8 downto 1 do
         if( FileName[i] = '.' ) or
           ( FileName[i] = ' ' ) then
            FileName[0] := chr( i-1 );
      SetViewPort( 0, 0, GetMaxX, GetMaxY, TRUE );
      MakeCursor;
      if FileName <> '' then
      begin
         FileName := Filename + '.CUR';
         Assign( CF, FileName );
         Rewrite( CF );
         writeln( CF, 'const');
         write  ( CF, '   ' +
             copy( FileName, 1, length(FileName)-4 ) );
         writeln( CF, ' : GCursor =');
         with NewCursor do
         begin
            Writeln( CF, '   (  ScreenMask : ( $',
                      HexToStr(ScreenMask[0]),  ', $',
                      HexToStr(ScreenMask[1]),  ', $',
                      HexToStr(ScreenMask[2]),  ', $',
                      HexToStr(ScreenMask[3]),  ',' );
            for i := 1 to 3 do
            begin
               write( CF, '                     $',
                   HexToStr(ScreenMask[i*4  ]),  ', $',
                   HexToStr(ScreenMask[i*4+1]),  ', $',
                   HexToStr(ScreenMask[i*4+2]),  ', $',
                   HexToStr(ScreenMask[i*4+3]) );
               if i < 3 then writeln( CF, ',' )
                        else writeln( CF, ' ); ' );
            end;
            writeln( CF, '      CursorMask : ( $',
                      HexToStr(CursorMask[0]), ', $',
                      HexToStr(CursorMask[1]), ', $',
                      HexToStr(CursorMask[2]), ', $',
                      HexToStr(CursorMask[3]), ',' );
            for i := 1 to 3 do
            begin
               write( CF, '                     $',
                   HexToStr(CursorMask[i*4  ]), ', $',
                   HexToStr(CursorMask[i*4+1]), ', $',
                   HexToStr(CursorMask[i*4+2]), ', $',
                   HexToStr(CursorMask[i*4+3]) );
               if i < 3 then writeln( cf, ',' )
                        else writeln( cf, ' ); ' );
            end;
            writeln( CF, '      hotX : $',
                     HexToStr(hotX), '; hotY : $',
                     HexToStr(hotY), ' );' );
         end;
         writeln( CF );
         Close( CF );
      end else Beep;
   end;

{-----------------------------------------------------------------}
{        Az egr-kurzor definicijnak beolvassa filer-bl       }
{-----------------------------------------------------------------}

procedure LoadPointer;
   var
      i, j, k, x, y: integer;
      Ch : char;
      CF : text;
      Done : Boolean;
      FileName : string[12];
      WorkText : string;
      TempVal  : word;
   begin
      i := 0;
      Done := FALSE;
      FileName := '........';
      SetViewPort( 269, 0, 369, 42, TRUE );
      SetTextJustify( CenterText, CenterText );
      Gmouse.SetCursor( ibeam );
      repeat
         inc(i);
         GMouse.Show( FALSE );
         ClearViewPort;
         SetColor( white);
         Rectangle( 0, 0, 100, 40 );
         OutTextXY( 50, 10, 'Betlts');
         OutTextXY( 50, 20, 'File-nv ?' );
         OutTextXY( 50, 30, FileName);
         GMouse.Show( TRUE );
         GMouse.SetPosition( 284+i*8,30 );
         repeat until KeyPressed;
         Ch := ReadKey;
         case Ch of
               #0   : begin Ch:=Readkey; dec(i,1); end;
               #$0D : Done := TRUE;
               #$08 : if( i > 1 ) then dec( i,2 );
            '0'..'9',
                 ' ',
            'A'..'Z',
            'a'..'z' : if( i > 8 ) then
                      begin
                         Beep;
                         dec(i,1);
                      end else FileName[i] := UpCase(Ch)
            else dec(i,1);
         end; {case}
      until Done;
      GMouse.SetCursor( arrow );
      SetColor( White);
      GMouse.Show( FALSE );
      ClearViewPort;
      SetViewPort( 0, 0, GetMaxX, GetMaxY, TRUE );
      GMouse.Show( TRUE );
      for i := 8 downto 1 do
         if( FileName[i] ='.' ) or
           ( FileName[i] =' ' ) then
             FileName[0] := chr(i-1);
      if FileName <> '' then
      begin
         FileName := FileName+'.CUR';
         Assign( CF, FileName );
           Reset( CF );
         if( IOresult = 0 ) then
         begin
            X := HotSpotX;
            Y := HotSpotY;
            HotSpotX := -1;
            HotSpotY := -1;
            PaintCursor( X, Y );
            PaintScreen( X, Y );
            ClearScreen;
            ClearCursor;
            i := 0;
            repeat
               readln( cf, WorkText );
               if Pos('$',WorkText) > 0 then
               for j := 1 to 4 do
               begin
                  while WorkText[1] <> '$' do
                     delete(WorkText,1,1);
                  delete(WorkText,1,1);
                  TempVal :=StrToHex(copy(WorkText,1,4));
                  case i of
                     0..15: for k := 0 to 15 do
                        begin
                          if ( TempVal and $8000 ) <> 0
                           then begin
                              Screen[k,i] :=TRUE;
                                PaintScreen(k,i);
                             end;
                             TempVal := TempVal shl 1;
                          end;
                       16..31: for k := 0 to 15 do
                          begin
                           if ( TempVal and $8000 ) <> 0
                            then Cursor[k,i-16] := TRUE;
                            PaintCursor(k,i-16);
                            TempVal := TempVal shl 1;
                         end;
                          32: HotSpotX := TempVal;
                          33: begin
                                HotSpotY := TempVal;
                                PaintCursor( HotSpotX,HotSpotY );
                                PaintScreen( HotSpotX,HotSpotY );
                                j := 4;
                             end;
                     end; {case}
                     inc( i );
                  end;
            until i > 33;
            Close( CF );
         end else Beep;
      end;
  end;


{-----------------------------------------------------------------}
{                        F  p r o g r a m                        }
{-----------------------------------------------------------------}

begin
      GDriver := grafdriver;
      GMode   :=grafmode;

      InitGraph( GDriver, Gmode, '' );
      GError := GraphResult;
      if GError <> grOk then
      begin
         writeln('Graphics error: ',GraphErrorMsg(GError));
         writeln('Program aborted...');
         halt(1);
      end;
      ClearDevice;
      HotSpotx:=0;
      HotSpoty:=0;

      Exit := FALSE;

      ScreenLayout;
      for i := 0 to 15 do
         for j := 0 to 15 do
         begin
            Screen[i,j] := TRUE;
            Cursor[i,j] := TRUE;
         end;

      ClearCursor;
      ClearScreen;
      Gmouse.Reset( mStatus, Buttons );
      if mStatus then
      begin
      SetWriteMode( CopyPut );
      Gmouse.Initialize;
      with GMouse do
      repeat
          QueryBtnDn( ButtonL, mButton );
          if MButton.opCount >0 then
          begin
             case mButton.yPos of
                 30..270 :
                   case mButton.xPos of
                       15..255 : ScreenSet( mButton );
                      279..359 : if mButton.yPos >= 250
                                    then SetHotSpot;
                      384..624 : CursorSet( mButton );
                   end;
                280..300 :
                   case mButton.xPos of
                       15.. 75 : ClearScreen;
                       85..145 : InvertScreen;
                      155..295 : ScreenFromCursor;
                      364..484 : CursorToScreen;
                      494..554 : InvertCursor;
                      564..624 : ClearCursor;
                   end;
                320..340 :
                     case mButton.xPos of
                         15..125 : UseNewCursor;
                        140..250 : SetCursor( arrow );
                        265..375 : LoadPointer;
                        390..500 : SavePointer;
                        515..625 : Exit := TRUE;
                     end;
                end;
             end;
          until Exit;
       end;
       TMouse.Reset( mStatus, Buttons );
       TMouse.SetCursor( hardware, 11, 12 );
       Beep;
       Closegraph;
       RestoreCrtMode;
 end.
