{OOPMOUSE.PAS}

{-----------------------------------------------------------------
 Az egrobjektum defincijt tartalmaz modul
 -----------------------------------------------------------------}

unit oopmouse;

interface

type

  position = record
               btnstat,                      { az egr gombok llapota    }
               opcount,      { a gomb lenyomsainak/felengedseinek szma }
               xpos, ypos : integer;         { az egr pozcija          }
             end;
   gcursor = record
               screenmask,                              { kpernymaszk   }
               cursormask : array [0..15] of word;      { az egr maszkja }
               hotx,hoty  : integer;           { kpernyrl val kifuts }
             end;

const
  buttonl = 0;         { a mouse bal oldali gombja     }
  buttonr = 1;         { a mouse jobb oldali gombja    }
  buttonm = 2;         { a mouse kzps gombja        }
  software = 0;        { szveges kurzor, software     }
  hardware = 1;        { szveges kurzor, hardware     }

{ nyl }
const
   ARROW : GCursor =
   (  ScreenMask : ( $1FFF, $0FFF, $07FF, $03FF,
                     $01FF, $00FF, $007F, $003F,
                     $003F, $003F, $00FF, $00FF,
                     $F07F, $F07F, $F87F, $F87F ); 
      CursorMask : ( $0000, $4000, $6000, $7000,
                     $7800, $7C00, $7E00, $7F00,
                     $7F80, $7C00, $4C00, $0600,
                     $0600, $0300, $0300, $0000 );
      hotX : $0001; hotY : $0001 );

{ pipa }
const
   CHECK : GCursor =
   (  ScreenMask : ( $FFF0, $FFE0, $FFC0, $FF81,
                     $FF03, $0E07, $040F, $001F,
                     $803F, $C07F, $E0FF, $F1FF,
                     $FFFF, $FFFF, $FFFF, $FFFF ); 
      CursorMask : ( $0000, $0006, $000C, $0018,
                     $0030, $0060, $60C0, $3180,
                     $1B00, $0E00, $0400, $0000,
                     $0000, $0000, $0000, $0000 ); 
      hotX : $0005; hotY : $000A );


{ kereszt }
const
   CROSS : GCursor =
   (  ScreenMask : ( $F01F, $E00F, $C007, $8003,
                     $0441, $0C61, $0381, $0381,
                     $0381, $0C61, $0441, $8003,
                     $C007, $E00F, $F01F, $FFFF ); 
      CursorMask : ( $0000, $07C0, $0920, $1110,
                     $2108, $4004, $4004, $783C,
                     $4004, $4004, $2108, $1110,
                     $0920, $07C0, $0000, $0000 );
      hotX : $0007; hotY : $0007 );


{ kz }
const
   GLOVE : GCursor =
   (  ScreenMask : ( $F3FF, $E1FF, $E1FF, $E1FF,
                     $E1FF, $E139, $E010, $8010,
                     $0000, $0000, $0000, $0000,
                     $8001, $8001, $C003, $E007 );
      CursorMask : ( $0C00, $1200, $1200, $1200,
                     $1200, $12C6, $1329, $7329,
                     $9339, $9001, $8001, $8001,
                     $4002, $4002, $2004, $1FF8 );
      hotX : $0004; hotY : $0000 );



{ I-rd }
const
   IBEAM : GCursor =
   (  ScreenMask : ( $E3C7, $E187, $F81F, $FC3F,
                     $FC3F, $FC3F, $FC3F, $FC3F,
                     $FC3F, $FC3F, $FC3F, $FC3F,
                     $FC3F, $F81F, $E187, $E3C7 ); 
      CursorMask : ( $0C30, $0240, $0180, $0180,
                     $0180, $0180, $0180, $0180,
                     $0180, $0180, $0180, $0180,
                     $0180, $0180, $0240, $0C30 ); 
      hotX : $0008; hotY : $0008 );



type
{-----------------------------------------------------------------}
{                 A GENMOUSE objektum defincija                 }
{-----------------------------------------------------------------}

    genmouse = object
        x,y : integer;        { az egr pozcii    }
        visible : boolean;    { az egr lthatsga }

        function testmouse:boolean;
        procedure setaccel(threshold:integer);
        procedure show(option:boolean);
        procedure getposition(var btnstatus, xpos, ypos:integer);
        procedure querybtndn(button:integer; var mouse:position);
        procedure querybtnup(button:integer; var mouse:position);
        procedure readmove(var xmove, ymove:integer);
        procedure reset(var status:boolean; var btncount:integer);
        procedure setratio(horpix, verpix:integer);
        procedure setlimits(xposmin, yposmin, xposmax, yposmax:integer);
        procedure setposition(xpos, ypos:integer);
    end;

{-----------------------------------------------------------------}
{    GRAPHICMOUSE a GENMOUSE leszrmazottja grafikus kpernyhz  }
{-----------------------------------------------------------------}

    graphicmouse = object (genmouse )
        procedure reset(var status : boolean; var btncount : integer);
        procedure initialize;
        procedure setcursor (cursor : gcursor );
    end;

{-----------------------------------------------------------------}
{     TEXTMOUSE a GENMOUSE leszrmazottja szveges kpernyhz    }
{-----------------------------------------------------------------}

    textmouse = object (genmouse )
        procedure initialize;
        procedure setcursor (ctype,c1,c2 : word );
    end;




implementation

uses crt,graph,dos;

var regs : registers;


function lower( n1, n2:integer):integer;
{          Az egr mozgsterlet-hatrnak ellenrzse  (max. rtk)    }
begin
  if n1 < n2 then lower:=n1 else lower:=n2;
end;


function upper( n1, n2:integer):integer;
{          Az egr mozgsterlet-hatrnak ellenrzse  (min. rtk)    }
begin
  if n1 > n2 then upper:=n1 else upper:=n2;
end;


function genmouse.testmouse:boolean;
{Feladat : a $33 interrupt aktivizlhatsgnak a tesztelse            }
const
  iret = 207;
var
  doff, dseg : integer;
begin
  doff:=memw [0000:0204];
  dseg:=memw [0000:0206];
  if ((dseg=0) or (doff=0))
  then testmouse:=false
  else testmouse:=mem [dseg:doff] <> iret;
end;


procedure genmouse.reset(var status:boolean; var btncount:integer);
begin
  regs.ax:=$00;               { az egr-driver inicializlsa }
  intr($33,regs);
  status:=regs.ax <> 0;       { inicializlt-e az egr   }
  btncount:=regs.bx;          { az egr gombjainak szma }
end;


procedure genmouse.setaccel(threshold :integer);
begin
  regs.ax:=$13;
  regs.dx:=threshold;  { a maximlis sebessg belltsa  (mickeys/second) }
  intr($33,regs);
end;


procedure genmouse.show(option:boolean);
begin
  if option and not visible
  then begin
         regs.ax:=$01;              { az egr lthatv ttele     }
         visible:=true;
         intr($33,regs);
       end
  else if visible and not option
       then begin
              regs.ax :=$02;        { az egr lthatatlann ttele }
              visible:=false;
              intr($33,regs);
            end;
end;


procedure genmouse.getposition(var btnstatus, xpos, ypos:integer);
begin
  regs.ax:=$03;            { az egr pozcijnak s gombjainak lekrdezse }
  intr($33,regs);
  btnstatus:=regs.bx;      { a hvs pillanatban a lenyomott gomb }
  xpos:=regs.cx;           { az egr x koordintja }
  ypos:=regs.dx;           { az egr y koordintja }
end;


procedure genmouse.setposition(xpos, ypos:integer);
begin
  regs.ax:=$04;            { az egr mozgatsa adott pozcira }
  regs.cx:=xpos;           { az egr x koordintja }
  regs.dx:=ypos;           { az egr y koordintja }
  intr( $33,regs);
end;


procedure genmouse.setratio(horpix, verpix:integer);
begin
  regs.ax:=$0f;       { az egr lpskznek a bellsa (mickey/8 pixels) }
  regs.cx:=horpix;    { a mozgs finomsga vizszintes irnyban }
  regs.dx:=verpix;    { a mozgs finomsga fggleges irnyban }
  intr($33,regs);
end;


procedure genmouse.querybtndn(button:integer; var mouse:position);
begin
  regs.ax:=$05;            { a gomb lenyomsainak szma   }
  regs.bx:=button;         { a vizsgland gomb           }
  intr($33,regs);
  mouse.btnstat:=regs.ax;  { a gomb llapota              }
  mouse.opcount:=regs.bx;  { a lenyomsok szma az utols vizsglat ta }
  mouse.xpos:=regs.cx;     { az egr x pozcija          }
  mouse.ypos:=regs.dx;     { az egr y pozcija          }
end;


procedure genmouse.querybtnup(button:integer; var mouse:position);
begin
  regs.ax:=$06;            { a gomb felengedeseinek szma }
  regs.bx:=button;         { a vizsgland gomb           }
  intr($33,regs);
  mouse.btnstat:=regs.ax;  { a gomb llapota              }
  mouse.opcount:=regs.bx;  { a felengedsek szma az utols vizsglat ta }
  mouse.xpos:=regs.cx;     { az egr x pozcija          }
  mouse.ypos:=regs.dx;     { az egr y pozcija          }
end;


procedure genmouse.setlimits(xposmin, yposmin, xposmax, yposmax:integer);
begin
  regs.ax:=$07;         { az egr mozgstartomnynak belltsa minx, maxx}
  regs.cx:=lower(xposmin,xposmax);
  regs.dx:=upper(xposmin,xposmax);
  intr($33,regs);
  regs.ax:=$08;         { az egr mozgstartomnynak belltsa miny, maxy}
  regs.cx:=lower(yposmin,yposmax);
  regs.dx:=upper(yposmin,yposmax);
  intr($33,regs);
end;


procedure genmouse.readmove(var xmove, ymove:integer);
begin
  regs.ax:=$0b;         { az egr elmozdulsa az utols hvs ta}
  intr($33,regs);
  xmove:=regs.cx;       { az egr elmozdulsa (mickey) (jobbra>0) }
  ymove:=regs.dx;       { az egr elmozdulsa (mickey) (lefele>0) }
end;


procedure graphicmouse.setcursor(cursor:gcursor);
begin
  regs.ax:=$09;                      { grafikus kurzor definilsa }
  regs.bx:=cursor.hotx;              { a kpernyrl val kifuts  }
  regs.cx:=cursor.hoty;
  regs.dx:=ofs (cursor.screenmask);  { a kurzormaszk lersa       }
  regs.es:=seg (cursor.screenmask);
  intr($33,regs);
end;


procedure graphicmouse.initialize;
{          A grafikus mouse alapbelltsai                             }
begin
  visible:=false;
  setlimits(0, 0, getmaxx, getmaxy);
  setcursor(arrow);
  setposition(getmaxx div 2, getmaxy div 2);
  show(true);
end;


procedure graphicmouse.reset(var status:boolean; var btncount:integer);
{         A grafikus mouse inicializlsa                        }
var gd,gm:integer;
begin
  detectgraph(gd, gm);
  if gd=7 then mem[0:$449]:=6;
  regs.ax:=$00;            { az egr-driver inicializlsa }
  intr($33,regs);
  status:=regs.ax <> 0;    { inicializlt-e                }
  btncount:=regs.bx;       { az egr gombjainak szma      }
end;


procedure textmouse.initialize;
{   A szveges mouse alapbelltsai                      }
begin
   visible:=false;
   setlimits (lo(windmin) * 8, hi(windmin) * 8,
              lo(windmax) * 8, hi(windmax) * 8);
   setcursor(hardware, 6, 7);
   setposition(0, 0);
   show(true);
end;


procedure textmouse.setcursor(ctype, c1, c2:word);
begin
  regs.ax:=$0a;   { a szveges egrkurzor belltsa        }
  regs.bx:=ctype; { software (0) vagy hardware kurzor (1)   }
  regs.cx:=c1; { a httrmaszk rtke (software) vagy a kezdsor (hardware) }
  regs.dx:=c2; { az eltrmaszk rtke (software) vagy a vgsor (hardware)  }
  intr($33,regs);
end;

end.

