(* chsru.pas *)
{--------------------------------------------------------------------
  karaktersorok felhasznlst tmogat sor objektum  defincija.
  a modult sorpld.pas program hasznlja.
 --------------------------------------------------------------------}

unit chsoru;

interface

const
   ureselem = #0;

type
  tsorelem = char;  { lehetne ms is! }

  alapelem = object             { az alapobjektum definilsa }
    destructor done; virtual;
  end;

  elemptr  = ^alapelem;
  elemlist = ^elemnode;
  elemnode = record
    elem : tsorelem;
    next : elemlist;
  end;

  { a sor objektum szrmaztatsa az alapobjektumbl }
  sorptr =^sor;
  sor    = object (alapelem)
    eleje, vege : elemlist;
    hossz, maxhossz : word;
    constructor    init;
    procedure      makenull;
    procedure      belep(i : tsorelem);
    function       kilep : tsorelem;
    function       ures : boolean;
    function       sorhossz : word;
    function       sormaxhossz : word;
    destructor     done; virtual;
  end;

implementation

  { az alapobjektum destruktora semmit sem tesz }
  destructor alapelem.done;
  begin
  end;

  { a sor konstruktora ltrehoz egy "eleje" s egy "vge" pointert
    s mind a kettt az sor elejre lltja }
  constructor sor.init;
  begin
    new(eleje);
    eleje^.next := nil;
    eleje^.elem := ureselem;
    vege := eleje;
    hossz := 0;
    maxhossz := 0;
  end;

  { a sorbl minden elemet kilptet a makenull metdus, ezzel
    egy res sort llt el }
  procedure sor.makenull;
  var p : elemlist;
  begin
    while eleje <> vege do
      begin
        p := eleje;
        eleje := eleje^.next;
        if p^.elem <> ureselem then
          p^.elem:=ureselem;
        dispose(p);
      end;
  end;

  { a belp elem hozzadsa a sor vghez }
  procedure sor.belep(i : tsorelem);
  begin
    inc(hossz);
    if hossz > maxhossz then maxhossz := hossz;
    new(vege^.next);
    vege := vege^.next;
    vege^.elem := i;
    vege^.next := nil;
  end;

  { a kilptet metdus a sor elejn tallhat elemet adja meg,
    elvgzi a pointerek mdostst, s felszabadtja a kilp
    elem szmra lefoglalt memrit. }
  function sor.kilep : tsorelem;
  var p : elemlist;
  begin
    if ures then kilep := ureselem
    else
      begin
        kilep := eleje^.next^.elem;
        p := eleje;
        eleje := eleje^.next;
        eleje^.elem := ureselem;
        dispose(p);
        dec(hossz);
      end;
  end;

  { a sor.ures metdus true rtkkel tr vissza, ha a sor res }
  function sor.ures : boolean;
  begin
    ures := eleje = vege;
  end;

  { lekrdezhet a sor aktulis hossza }
  function sor.sorhossz : word;
  begin
    sorhossz := hossz;
  end;

  {lekrdezhet a sor maximlis hossza }
  function sor.sormaxhossz : word;
  begin
    sormaxhossz := maxhossz;
  end;

  { a sor objektum destruktora, amely meghvja a makenull metdust
    ( az els elem kivtelvel minden elem kilp a sorbl), majd
    felszabadtja az els elemet }
   destructor sor.done;
  begin
    makenull;
    dispose(eleje);
  end;

end.