(* telefon.pas *)
program telefonkonyv;
uses crt;

const
   telbook : string = 'telefon.dat';
   be = true; ki = false;

type
   telefon=record
             nev : string[30];
             cim : string[50];
             tel : string[12];
           end;

var
    telfile: file of telefon;
    ch     : char;

{----------------------------------------------}
{  A rgi telefonknyvet megnyit vagy az jat }
{             ltrehoz eljrs.               }
{----------------------------------------------}
procedure opentel;
var
    tknev  : string;
begin
  gotoxy(20,13);
  write('Krem a telefonknyv fjl nevt: ');
  readln(tknev);
  if tknev<>'' then telbook:=tknev;
  clrscr;
  assign(telfile,telbook);
  {$I-}
  reset(telfile);
  {$I+}
  if ioresult<>0 then
                    begin
                      writeln('Uj telefonknyv: ',telbook);
                      rewrite(telfile);
                    end
                  else
                      writeln('Rgi telefonknyv: ',telbook);
end;

{----------------------------------------------}
{ A telefon tpus adatok olvassa, kirsa    }
{----------------------------------------------}
procedure teladat(var tr : telefon; beker : boolean);
begin
  with tr do
    begin
       gotoxy(10,6);  write('Nv         :  ');
       if beker then readln(nev) else write(nev);
       gotoxy(10,8);  write('Lakcm      :  ');
       if beker then readln(cim) else write(cim);
       gotoxy(10,10); write('Telefonszm :  ');
       if beker then readln(tel) else write(tel);
    end;
end;

{----------------------------------------------}
{ Az s1 keresse az s2-ben, a kis- s nagybetk}
{         megklnbztetse nlkl             }
{----------------------------------------------}
function hasonlit(s1,s2:string):boolean;
var i:byte;
begin
  if s1='' then
       begin
         hasonlit:=true;
         exit;
       end;
  for i:=1 to length(s1) do
      s1[i]:=Upcase(s1[i]);
  for i:=1 to length(s2) do
      s2[i]:=Upcase(s2[i]);
  hasonlit:=pos(s1,s2)<>0;
end;

{----------------------------------------------}
{ Adatok bevitele a meglv elemek tlpsvel }
{----------------------------------------------}
procedure felvitel;
var
    telrec : telefon;
begin
  opentel;
  { Pozicionls a fjl vgre }
  seek(telfile,filesize(telfile));
  teladat(telrec, be);
  write(telfile,telrec);
  close(telfile);
end;

{----------------------------------------------}
{  Soros keress a definilt maszkok alapjn   }
{----------------------------------------------}
procedure kereses;
var
    keres,telrec : telefon;
    van          : array [1..3] of boolean;
begin
  opentel;
  if eof(telfile) then { res fjl }
             begin
               close(telfile);
               write(#7);
               exit;
             end;

  gotoxy(10,4); write('Krem a keresend szvegrszleteket:');
  gotoxy(10,14);
  write('Tovbb brmely billentyvel');
  window(1,2,80,12);
  teladat(keres, be);
  seek(telfile,0);
  while not eof(telfile) do
     begin
       read(telfile,telrec);
       van[1]:=hasonlit(keres.nev,telrec.nev);
       van[2]:=hasonlit(keres.cim,telrec.cim);
       van[3]:=hasonlit(keres.tel,telrec.tel);
       if van[1] and van[2] and van[3] then
          begin
              clrscr;
              teladat(telrec, ki);
              repeat until keypressed;
              ch:=readkey;

          end;
     end;

  window(1,1,80,25);
  close(telfile);
end;

{----------------------------------------------}
{    Vletlenszer pozicionls a fjlban     }
{----------------------------------------------}
procedure lapozgatas;
var
    telrec : telefon;
    poz    : longint;
    rsz    : longint;
begin
  opentel;
  if eof(telfile) then  { res fjl }
             begin
               close(telfile);
               write(#7);
               exit;
             end;

  gotoxy(10,14);
  write('Tovbb brmely billentyvel - Kilps: ESC');

  window(1,2,80,12);
  rsz:=filesize(telfile);
  randomize;

  while true do
     begin
       poz:=random(rsz);
       seek(telfile,poz);
       read(telfile,telrec);

       clrscr;
       teladat(telrec, ki);
       repeat until keypressed;
       ch:=readkey;

       { Kilps az eljrsbl az ESC billentyvel}
       if ch=#27 then
                   begin
                      window(1,1,80,25);
                      close(telfile);
                      exit;
                   end;
     end;

end;

begin
   {----------------------------------------------}
   {       A program vezrlst vgz men        }
   {----------------------------------------------}
   while true do
    begin
       clrscr;
       gotoxy(30,2);  writeln('Vlasszon:');
       gotoxy(20,4);  writeln('1: Uj telefonszmok felvitele');
       gotoxy(20,6);  writeln('2: Keress a telefonknyvben');
       gotoxy(20,8);  writeln('3: Lapozgats a telefonknyvben');
       gotoxy(20,10); writeln('4: Kilps a programbl');

       repeat until keypressed;
       ch:=readkey;

       case ch of
         '1':  felvitel;
         '2':  kereses;
         '3':  lapozgatas;
         '4':  exit;
         else
              begin
                gotoxy(25,13);
                writeln('Hibs vlaszts!');
                delay(500);
              end;
       end;
   end;
end.

