(* obj_6.pas *)
program obj_6;
uses crt,graph;
type
  PPozicio = ^Pozicio;
  Pozicio = object
     x, y    : integer;
     r_szin  : word;
     f_szin  : word;
     f_minta : word;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta: word);
     destructor Done;
     procedure Grafika;
     procedure Rajzol; virtual;
  end;

constructor Pozicio.Init;
 begin
   x:= x_koord;
   y:= y_koord;
   r_szin:= rajzszin;
   f_szin:= festoszin;
   f_minta:= minta;
 end;

procedure Pozicio.Grafika;
 begin
   Rajzol;
 end;

procedure Pozicio.Rajzol;
 var Gd, Gm: integer;
 begin
   Gd:= VGA;
   Gm:= VGAHi;
   InitGraph(Gd, Gm, '');
   if GraphResult <> GrOK then Halt(1);
   SetBkColor(BLUE);
 end;

destructor Pozicio.Done;
 begin
 end;

type
  PTeglalap = ^Teglalap;
  Teglalap = object(Pozicio)
     a, b: integer;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta : word;
                      a_old, b_old : integer);
    destructor Done;
    procedure Rajzol; virtual;
  end;

constructor Teglalap.Init;
 begin
   inherited Init(x_koord, y_koord,
                  rajzszin, festoszin, minta);
   a:= a_old;
   b:= b_old;
 end;

procedure Teglalap.Rajzol;
 begin
   inherited Rajzol;
   SetFillStyle(f_minta, f_szin);
   SetColor(r_szin);
   SetLineStyle(SolidLn, 0, ThickWidth);
   Bar(x, y, round(a), round(b));
   Rectangle(x, y, round(a), round(b));
   readln;
   Closegraph;
 end;

destructor Teglalap.Done;
 begin
 end;

type
  PHaromszog = ^Haromszog;
  Haromszog = object(Pozicio)
     a, m: integer;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta : word;
                      a_old, m_old : integer);
     destructor Done;
     procedure Rajzol; virtual;
  end;

constructor Haromszog.Init;
 begin
   inherited Init(x_koord, y_koord,
                  rajzszin, festoszin, minta);
   a:= a_old;
   m:= m_old;
 end;

destructor Haromszog.Done;
 begin
 end;

procedure Haromszog.Rajzol;
 var HSz   : array[1..4] of PointType;
 begin
   inherited Rajzol;
   SetBkColor(LIGHTCYAN);
   SetFillStyle(f_minta, f_szin);
   SetColor(r_szin);
   SetLineStyle(SolidLn,0,ThickWidth);
   HSz[1].X:= x;
   HSz[1].Y:= y;
   HSz[2].X:= x ;
   HSz[2].Y:= y-m;
   HSz[3].X:= x+a;
   HSz[3].Y:= y-m;
   HSz[4].X:= x;
   HSz[4].Y:= y;
   DrawPoly(SizeOf(HSz) div SizeOf(PointType), HSz);
   FillPoly(4, HSz);
   readln;
   Closegraph;
 end;

var
  pt: PTeglalap;
  ph: PHaromszog;
begin
  clrscr;

  writeln('Tglalap rajzolsa ');
  new(pt,Init(20,50,LIGHTRED,YELLOW,LineFill,50,100));
  writeln('x koordinta : ', pt^.x:3);
  writeln('y koordinta : ', pt^.y:3);
  writeln('a oldal      : ', pt^.a:3);
  writeln('b oldal      : ', pt^.b:3);
  writeln('A rajzols megkezdshez');
  writeln('nyomjon <Enter>-!');
  readln;
  pt^.Grafika;
  dispose(pt,Done);
  writeln;

  writeln('Hromszg rajzolsa');
  new(ph,Init(100,150,RED,BLUE,LineFill,50,70));
  writeln('x koordinta : ', ph^.x:3);
  writeln('y koordinta : ', ph^.y:3);
  writeln('alap         : ', ph^.a:3);
  writeln('magassg     : ', ph^.m:3);
  writeln('A rajzols megkezdshez');
  writeln('nyomjon <Enter>-!');
  readln;
  ph^.Grafika;
  dispose(ph,Done);
end.