(* intrdos.pas *)

program intrdos;
uses dos, crt;

{ Szvegkurzor ki- /bekapcsolsa}
{ true - bekapcsols, false - kikapcsols }
procedure kurzor(ki_be:boolean);
 const cur: word = $0607;
 var   r  : registers;
 begin
  case ki_be of
    false : {kikapcsols}
            begin
              {a kurzoralak lekrdezse}
              r.ah:=3;
              r.bh:=0;
              intr($10,r);
              cur:=r.cx;
              {a kurzoralak lltsa}
              r.ah:=1;
              r.cx:=$2000;
              intr($10,r);
            end;
    true  : { bekapcsols }
            begin
              {a kurzoralak visszalltsa}
              r.ah:=1;
              r.cx:=cur;
              intr($10,r);
            end;
  end;
end;

{DOS verziszm kirsa}
procedure dosver;
 var
   r : registers;
 begin
   r.ah:=$30;
   MsDos(r);
   writeln('Az opercis rendszer verziszma: ',
            r.al, '.', r.ah);
 end;

{ a mai dtum megjelentse }
procedure maidatum;
 var
   r : registers;
   datum, ev, ho, nap: string;
 begin
   r.ah := $2a;
   msdos(r);
   with r do
     begin
       str(cx ,ev);
       str(dh ,ho);
       str(dl,nap);
     end;
   writeln('A mai dtum : ', ev+'.'+ho+'.'+nap);
 end;

{ A hajlkonylemez bootszektornak megjelentse }
procedure bootsec;
 var
   r : registers;
   puffer   : array[0..511] of char;
   i, j : integer;
   ch : char;
 begin
   { a lemezvezrl inicializlsa: }
   r.ah:=0;
   r.dl:=0;
   intr($13,r);
   { az A: lemez bootszektornak beolvassa: }
   with r do
     begin
       ah:=2;                { szektor olvassa}
       dl:=0;                { meghajt A:     }
       dh:=0;                { fej: 0          }
       al:=1;                { szektorok szma }
       cx:=1;                { sv:0 /szektor:1}
       es:=seg(puffer);
       bx:=ofs(puffer);
     end;
   intr($13,r);
   if (r.flags and fCarry)<>0 then
      begin
       writeln('Hibs mvelet!  Hibakd: ',r.ah);
       exit;
      end;
   writeln('A bootszektor:');
   writeln;
   for i:= 0 to 15 do
    begin
     write(i*32:3,'  ');
     for j:=0 to 31 do
       begin
        ch:=puffer[i*32+j];
        if ch<=#32 then ch:='.';
        write(ch:2);
       end;
     writeln;
    end;
 end;

{ a fprogram }
begin
  clrscr;
  kurzor(false);  { a szvegkurzor kikapcsolsa }
  dosver;
  writeln;
  maidatum;
  writeln;
  bootsec;
  delay(2000);
  kurzor(true);  { a szvegkurzor bekapcsolsa }
  readln;
 end.
