(* SCR_SAVE.PAS *)
{ ----------------------------------------------------------- }
{ A program a 25 x 80 -as szveges kperny szvegtartalmt a }
{ megadott nev fjlba menti.                                 }
{                                                             }
{  Telepts:                                                 }
{    scr_save fjlnv                                         }
{                                                             }
{  Aktivizls:                                               }
{    a  <Print Screen> (<PrtSc>) billentyvel                 }
{                                                             }
{  A program a kperny kimentst hanggal jelzi,             }
{  s felszabadtja az ltala lefoglalt memrit.             }
{ ----------------------------------------------------------- }
{$M $1024,0,0 }
program screen_save;
uses dos, crt;

const
  to_save : boolean = false;
  size   = 2000;
  scrseg = $b800; { $b000 Hercules ,
                  $b800 CGA, EGA, VGA szveges kperny}

type
  puffertype = array[1..size] of byte;

var
    it28old : procedure;   { a rgi int $28 rutin belpse }
    it05old : pointer;     { a rgi int $05 rutin cme     }

    puffer   : puffertype; { puffer a kprny trolshoz }
    psp, env : word;       { a memria felszabadtshoz szksges rtkek }
    regs     : registers;  { rekord a dos hvsokhoz }
    param    : string[32]; { a paramtersorban definilt fjlnv }
    pf       : file of puffertype;
    k, l     :integer;

  procedure cli;   inline($fa);   { a hw megszaktsok tiltsa       }
  procedure sti;   inline($fb);   { a hw megszaktsok engedlyezse }
  procedure pushf; inline ($9c);  { az llapotregiszter elmentse }

{ hangjelzs }
procedure signal;
 begin
   sound(2500); delay(20);
   sound(1000); delay(10);
   nosound;
 end;

{ --------------------------------------------------------------- }
{ megszaktskezel eljrs a $05 vektor tdefinilshoz         }
{                                                                 }
{ a megszaktskezel a kvetkez tevkenysgeket vgzi:          }
{ - tmsolja a kperny szvegtartalmt a pufferba,              }
{ - belltja a to_save jelzt true-ra (van kimentend puffer),   }
{ - visszalltja az eredeti $05 interrupt vektort.               }
{ --------------------------------------------------------------- }
procedure it05; interrupt;
 begin
    cli;
    { a puffer feltltse }
    l:=1;
    if not to_save then
        for k:=0 to 3999 do
           if not odd(k) then
             begin
              puffer[l]:=mem[scrseg:k];
              if  puffer[l]<32 then puffer[l]:=32;
              inc(l);
            end;

     to_save:=true;
     { a rgi it visszalltsa }
     setintvec($05,it05old);
     sti;
 end;

{ ----------------------------------------------------------------- }
{ megszaktskezel  eljrs a $28 vektor tdefinilshoz          }
{                                                                   }
{ a megszaktskezel a kvetkez tevkenysgeket vgzi:            }
{ - a puffer tartalmt fjlba rja,                                 }
{ - belltja a to_save jelzt false-ra,                            }
{ - felszabadtja a lefoglalt memrit,                             }
{ - visszalltja az eredeti $28 interrupt vektort.                 }
{ ----------------------------------------------------------------- }
procedure it28; interrupt;
 begin
   if not to_save then
      { ha nem kell mg menteni, csak a rgi it-t hvja meg }
      begin
        pushf;
        it28old;
      end
    else
      begin
       { fjlba ments}
         assign(pf,param);
         rewrite(pf);
         write(pf,puffer);
         close(pf);

         to_save:=false;

         setintvec($28,@it28old);

         { a programterlet felszabadtsa }
         regs.ah := $49;
         regs.es := psp;
         msdos(regs);
         { a dos krnyezet felszabadtsa }
         regs.ah := $49;
         regs.es := env;
         msdos(regs);

         signal;
     end;
 end;

{ ----------------------------}
{ a paramtersor feldolgozsa }
{ ----------------------------}
function paramtest:boolean;
 begin
   paramtest:=false;

   { van-e paramter megadva ?}
   if paramcount=0 then
   begin
     writeln('Hasznlat: scr_save fjlspec.');
     exit;
   end;

   { rvnyes fjlnv-e az els paramter }
   param := paramstr(1);
   assign(pf,param);
   {$i-}
   rewrite(pf);
   {$i+}
   if ioresult<>0 then exit;
   close(pf);
   erase(pf);
   paramtest:=true;
 end;

{ ---------------------}
{ a telept fprogram }
{ ---------------------}
begin
  { a paramtersor ellenrzse }
  if not paramtest then
                     begin
                       signal;
                       halt;
                     end;
  to_save:=false;

  {  a psp s a dos krnyezet szegmenscmeinek lekrdezse }
  regs.ah := $62;
  msdos(regs);
  psp := regs.bx;
  env := memw[psp:$2c];

  { a megszaktsvektorok elmentse s belltsa}
  getintvec($05,it05old);
  getintvec($28,@it28old);

  setintvec($05,addr(it05));
  setintvec($28,addr(it28));

  { TSR kilps }
  keep(0);
end.

