(*-------------------------------------------------------------*
                              PORTCOM.PAS

    A soros adatvitelt megvalst program, amely a vezrl
    kzvetlen programozsval mkdik. Az biztonsgos adatfogads
    rdekben a program megszaktst s soros puffert hasznl.
    A soros port kezelst a SERIALU.PAS modul vgzi.
 *-------------------------------------------------------------*)

{$X+}
program PORT_soros_kommunikacio;
uses crt, serialu;
const
     ESC       = $1B;

{----------------------}
{ A tesztel fprogram }
{----------------------}
var
  cport : serialport;
  c : word;
  done : boolean;
  ps : string[1];

begin
  done:=false;
  if (paramcount<>1) or ((paramstr(1)<>'1') and (paramstr(1)<>'2')) then
     begin
       writeln('Hasznlat: PORTCOM 1 | 2');
       halt;
     end;

  { A parancssor feldolgozsa: 1 - COM1, 2 - COM2) }
  ps :=paramstr(1);
  cport := serialport(ord(ps[1])-49);

  { A kommunikcis paramterek megadsa }
  initcom(cport);
  setprotocol(cport,9600,8,1 ,None);

  textbackground(BLACK);
  clrscr;

  textcolor(GREEN);
  writeln('TURBO Pascal soros kommunikcis program');
  writeln('... kilps az <ESC> billentyvel ...');

  { A program fciklusa, amely a billentyzet- s a   }
  { soros portrl egyarnt feldolgozza a karaktereket }
  repeat
      { Olvass a billentyzetpufferbl }
      if keypressed then
      begin
          c:=ord(readkey);
	  case (c) of
	      ESC:  { Kilps }
                    done := true;
              13 :  { Soremels }
                    writeln;
	      else  { Echo }
                   begin
		     textcolor(GREEN);
		     write(chr(c));
                   end;
	  end;
	  { A karakter elkldse }
	  PutChar(cport,chr(c));
      end;
      { Ha van rvnyes adat, olvass a soros portrl: }
      if (not done) and (AskCharNum(cport)>0) then
        begin
          c := ord(GetChar(cport));
          case c of
            13 : { Soremels }
                 writeln;
            ESC: { Kilps }
                 done := true;
            else
               begin
                 textcolor(CYAN);
                 write(chr(c));
               end;
        end;
      end;
  until (done);
  resetcom(cport);
  textcolor(LIGHTGRAY);
  writeln;
  writeln('Viszlt!');
 end.
