(* asc2bin.pas *)

{ A program a BIN2ASC programmal kdolt llomnyokat
  eredeti formban lltja vissza }
program asc2bin;

 const
  sp = 32;

 type
  tharmas = array[0..2] of byte;
  tnegyes = array[0..3] of byte;

var fasc : text;
    fbin : file of byte;
    fnev: string[12];
    buffer: string;
    negyesek: record
                strlen : byte;
                shossz : byte;
                negyes :  array[1..64] of tnegyes;
              end absolute buffer;
    harmas: tharmas;
    i: integer;

{ Az s sztringet nagybetss alaktja}
function upperstr(s : string) : string;
 var slen : byte absolute s;
     i    : byte;
 begin
   for i := 1 to slen do
      s[i] := upcase(s[i]);
   upperstr := s;
 end;

{ 4*6 bitbl -> 3*8 bit ellltsa }
procedure negyes2harmas(negyes: tnegyes; var harmas: tharmas);
 begin
   harmas[0] :=  ((negyes[0] - sp) shl 2) + (((negyes[1] - sp) and $30) shr 4);
   harmas[1] := (((negyes[1] - sp) and $0f) shl 4) + (((negyes[2] - sp) and $3c) shr 2);
   harmas[2] := (((negyes[2] - sp) and $03) shl 6) + ((negyes[3] - sp) and $3f)
 end;


{ a fprogram }
begin

  { ha nincs paramter}
  if paramcount = 0 then
  begin
    writeln('Hasznlat: ASC2BIN ascii fjl [binris fjl]');
    halt
  end;

  { ha a kt paramter megegyezik}
  if upperstr(paramstr(1)) = upperstr(paramstr(2)) then
  begin
    writeln(#7'Hiba: bemeneti fjl = kimeneti fjl');
    halt(1)
  end;

  { az ascii llomny megnyitsa }
  assign(fasc,paramstr(1));
  {$I-} reset(fasc); {$I+}
  if ioresult <> 0 then
  begin
    writeln(#7'Hiba: a(z) ',paramstr(1),' llomny nem nyithat meg!');
    halt(2)
  end;

  { a kdok kezdetnek keresse: begin ... }
  repeat
    readln(fasc,buffer)
  until eof(fasc) or (copy(buffer,1,5) = 'begin');

  { a fjlban trolt fjlnv, vagy a 2. paramter }
  if buffer[11] = #32
   then
     fnev := copy(buffer,12,12)
   else
     if buffer[10] = #32 then fnev := copy(buffer,11,12)
                         else fnev := paramstr(2);


  { ha a kt fjlnv megegyezik}
  if upperstr(paramstr(1)) = upperstr(fnev) then
  begin
    writeln(#7'Hiba: bemeneti fjl = kimeneti fjl');
    halt(1)
  end;

  { a binris llomny ltezsnek ellenrzse }
  assign(fbin, fnev);
  if paramcount > 1 then
  begin
    {$I-} reset(fbin); {$I+}
    if ioresult = 0 then
    begin
      writeln(#7'Hiba: a(z) ',fnev,' llomny mr ltezik!');
      halt(3)
    end
  end;

  { a binris llomny megnyitsa }
  {$I-} rewrite(fbin); {$I+}
  if ioresult <> 0 then
  begin
    writeln(#7'Hiba: nem sikerlt ltrehozni a(z) ',fnev,' llomnyt!');
    halt(4)
  end;

  { asc -> bin konverzi }
  while (not eof(fasc)) and (buffer <> 'end') do
  begin
    fillchar(buffer, sizeof(buffer),#32);
    readln(fasc, buffer);
    if buffer <> 'end' then
    begin
      for i:=1 to (negyesek.shossz-sp) div 3 do
         begin
           negyes2harmas(negyesek.negyes[i], harmas);
           write(fbin, harmas[0], harmas[1], harmas[2])
         end;
      if ((negyesek.shossz-sp) mod 3) > 0 then
         begin
           negyes2harmas(negyesek.negyes[i+1],harmas);
           for i:=1 to ((negyesek.shossz-sp) mod 3) do
               write(fbin,harmas[i-1])
         end
    end
  end;

  close(fasc);
  close(fbin);

  writeln('A visszakonvertlt llomny: ',fnev);
  writeln
end.
