(* rejto.pas *)

program fajl_titkosito;
uses crt;

type puf=array[1..255] of char;

var
  tf        :  file;
  nok       : word;
  puffer    : puf;
  pwh, i       : integer;
  ch        : char;
  pw        : string;


const nl = #13;
      bs = #8;

type tcharset = set of char;

{ Jelsz bekrse
  fed    : a fedkarakter,
  okchar : karakterkszlet
}
function getpwd(fed : char; okchar : tcharset): String;
var
  ch : char;
  pwd : string;
begin
  pwd := '';
  repeat
    ch := readkey;

    if ch=#0 then  { Minden vezrlkarakter hibs }
               begin
                  ch:=readkey;
                  ch:=#1;
               end;

    if (ch=#8) and (pwd[0]<>#0) then  { Visszatrls }
               begin
                  dec(pwd[0]);
                  gotoxy(wherex-1, wherey);
                  write(' ');
                  gotoxy(wherex-1, wherey);
               end;

    if (ch in okchar) then
               begin
                 write(fed);
                 pwd := pwd + ch
               end
    else
      if not (ch in [nl, bs]) then write(^G); { sipol }
  until (ch = nl);
  getpwd := pwd
end;

procedure halterr(msg:string);
begin
 writeln(#7,'Futsi hiba :  ',msg);
 writeln(#7,'a program futsa megszakadt.');
 halt;
end;

begin
  { A paramterezs tesztelse }
  if paramcount<>1 then
    halterr(#13+#10+#13+#10+'Hasznlat: TITKOS llomny'+ #13+#10);

  { A fjl ellenrzse }
  assign(tf, paramstr(1));
  {$I-}
  reset(tf, 1);
  {$I+}
  if ioresult<>0 then
     halterr('nem elrhet fjl: '+paramstr(1));

  pw:='';
  clrscr;
  writeln('A feldolgozand llomny : ', paramstr(1));
  writeln;
  write('Krem a jelszt : '); pw:=getpwd('*',[#32..#255]);
  writeln;

  if pw='' then halterr('res jelsz');
  pwh:=length(pw);

  { Titkosts }
  randseed:=pwh;
  repeat
     blockread(tf,puffer,pwh,nok);
     for i:=1 to nok do
        puffer[i]:= chr(ord(pw[i]) xor ord(puffer[i]) xor random(maxint));
     seek(tf,filepos(tf)-nok);
     blockwrite(tf,puffer,nok,nok);
  until (nok < pwh);

  close(tf);
end.


