(* ablaku.pas *)

unit tablaku;

interface
const
    vekony = 1;
    dupla  = 2;
    vastag = 3;

{ Ablak ksztse:
  (x1,y1) - (x2,y1) bal fels sarok - jobb als sarok
  ftype   -  kerettpus : 1, 2, 3
  back    -  httrszn,
  pen     -  betszn,
  header  -  fejlc }
procedure mkwin(x1, y1, x2, y2, ftype, back, pen : byte; header : string);

{ az utoljra kitett ablak levtele }
procedure clrwin;

implementation

uses keretu, crt;

const
    maxwindow = 200;

type
  pchar = ^char;
  savewin = record   { ablakinfomcik }
              pw : pchar;
              ps : word;
              x1, y1, x2, y2   : byte;
              xp, yp : byte;
              tb, tc : integer;
            end;


const
   stptr:word = 0;  { a veremmutat }

var
   wstack : array [0..maxwindow] of savewin ;


{ hibajelzs helyett nil pointer }
function HeapFunc(size:word) :integer; far;
 begin
   heapfunc:=1;
 end;


{ A helyes terletkijells ellenrzse
  - (a1,a2) : a bal fels sarok koordinti
  - (b1,b2) : a jobb als sarok koordinti }
function ellenor(a1,a2,b1,b2:byte):boolean;
 var ok:boolean;
 begin
   ok:=true;
   if (a1>=b1) or (a2>=b2) then ok:=false;
   if not((a1 in [1..80]) and (a2 in [1..25])) then ok:=false;
   if (b1<1)  or (b1>80) and (b2<1) or (b2>25) then ok:=false;
   ellenor:=ok;
 end;


{ a megadott kpernyablak lementse }
procedure gettext(x1, y1, x2, y2 : byte; var p);
 var index : integer;
     screen : array [1..25, 1..80] of word absolute $b800:0;
     puf    : array [1..2001] of word  absolute p;
     meret  : array [1..2] of byte absolute p;
     s, o   : byte;
 begin
    meret[1]:=x2-x1; { x mret }
    meret[2]:=y2-y1; { y mret }
    index:=2; { az els sz a mretet tartalmazza }
    for s:=y1 to y2 do
     for o:=x1 to x2 do
       begin
         puf[index]:=screen[s,o];
         inc(index);
       end;
 end;

{ a megadott kpernyablak visszatltse adott pozcira }
procedure puttext(x,y: byte; var p);
 var index : integer;
     screen : array [1..25, 1..80] of word absolute $b800:0;
     puf    : array [1..2001] of word  absolute p;
     meret  : array [1..2] of byte absolute p;
     s, o   : byte;
 begin
    index:=2;
    for s:=y to y+meret[2] do
     for o:=x to x+meret[1] do
       begin
         screen[s,o]:=puf[index];
         inc(index);
       end;
 end;


procedure keretez(x1, y1, x2, y2, ktip, hszin, kszin : byte; szoveg : string);
  var
    wt, ww : integer;
  begin
    keretu.torol(x1, y1, x2, y2, hszin);
    keretu.keret(x1, y1, x2, y2, ktip, kszin);
    ww:=x2-x1;
    wt:=length(szoveg);
    gotoxy(x1+(ww-wt) div 2+1 ,y1);
    write(szoveg);
  end;

{ Ablak ksztse:
  (x1,y1) - (x2,y1) bal fels sarok - jobb als sarok
  ftype   -  kerettpus : 1, 2, 3
  back    -  httrszn,
  pen     -  betszn,
  header  -  fejlc
}
procedure mkwin(x1, y1, x2, y2, ftype, back, pen : byte; header : string);
var wsize:integer;
    wptr : pchar;
begin
     if not ellenor(x1,y1,x2,y2) then exit;
     wsize:=(x2-x1+1)*(y2-y1+1);
     getmem(wptr, 2*wsize+2);
     if wptr=nil then
                    begin
                      writeln(#7'Nincs elg memria');
                      halt;
                    end;
     gettext(x1,y1,x2,y2,wptr^);

     inc(stptr);                { a veremmutat lptetse }

     wstack[stptr].pw:= wptr;
     wstack[stptr].ps:= 2*wsize+2;
     wstack[stptr].x1 := x1;
     wstack[stptr].y1 := y1;
     wstack[stptr].x2 := x2;
     wstack[stptr].y2 := y2;
     wstack[stptr-1].xp := wherex;
     wstack[stptr-1].yp := wherey;
     wstack[stptr].tb := back;
     wstack[stptr].tc := pen;

     keretez(x1,y1,x2,y2,ftype,back,pen,header);
     window(x1+1,y1+1,x2-1,y2-1);

     textbackground(back);
     textcolor(pen);
     gotoxy(1,1);
 end;

{ az utoljra kitett ablak levtele }
procedure clrwin;
 begin
   if stptr = 0 then exit;
   with wstack[stptr] do
     begin
      puttext(x1, y1, pw^);
      freemem(pw, ps);
     end;
   dec(stptr);
   { az utols eltti ablak aktivizlsa }
   if (stptr>0) then
     with wstack[stptr] do
       begin
         window(x1+1,y1+1,x2-1,y2-1);
         textbackground(tb);
         textcolor(tc);
         gotoxy(xp, yp);
       end
       else
        begin
	 window(1,1,80,25);
         textbackground(torolszin);
         textcolor(keretszin);
         with wstack[0] do gotoxy(xp, yp);
        end;
end;


begin
  HeapError:=@HeapFunc;
end.

