(* obj_5.pas *)
program obj_5;
uses crt, graph;

type
  Pozicio = object
     x, y       : integer;
     r_szin     : word;
     f_szin     : word;
     f_minta    : word;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta: word);
     destructor Done;
     procedure Grafika;
     procedure Rajzol; virtual;   { virtulis metdus }
  end;

constructor Pozicio.Init;
 begin
   x:= x_koord;
   y:= y_koord;
   r_szin:= rajzszin;
   f_szin:= festoszin;
   f_minta:= minta;
 end;

procedure Pozicio.Grafika;
 begin
   Rajzol;
 end;

procedure Pozicio.Rajzol;
 var Gd, Gm: integer;
 begin
   Gd:= VGA;
   Gm:= VGAHi;
   InitGraph(Gd, Gm, '');
   if GraphResult <> GrOK then Halt(1);
   SetBkColor(BLUE);
 end;

destructor Pozicio.Done;
 begin
 end;

type
  PTeglalap = ^Teglalap;
  Teglalap = object(Pozicio)
     a, b: integer;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta : word;
                      a_old, b_old : integer);
     procedure Rajzol; virtual;
     destructor Done;
  end;
constructor Teglalap.Init;
 begin
   inherited Init( x_koord, y_koord,
                   rajzszin, festoszin, minta);
   a:= a_old;
   b:= b_old;
 end;

procedure Teglalap.Rajzol;
 begin
   inherited Rajzol;
   SetFillStyle(f_minta, f_szin);
   SetColor(r_szin);
   SetLineStyle(SolidLn,0,ThickWidth);
   Bar(x, y, round(a), round(b));
   Rectangle(x, y, round(a), round(b));
   readln;
   Closegraph;
 end;

destructor Teglalap.Done;
 begin
 end;

var
  pt: PTeglalap;
begin
  clrscr;
  writeln('Tglalap rajzolsa');
  writeln; writeln('A httr szine kk ');
  writeln('A tglalap kerete : vilgospiros ');
  writeln('A tglalap belseje: srga s vzszintes cskozs');
  new(pt,Init(20,50,LightRed,Yellow,LineFill,50,100));
  writeln('x koordinta : ',pt^.x:3);
  writeln('y koordinta : ',pt^.y:3);
  writeln('a oldal      : ',pt^.a:3);
  writeln('b oldal      : ',pt^.b:3);
  writeln('A rajzols megkezdshez nyomjon <Enter>-t!');
  readln;
  pt^.Grafika;
  dispose(pt,Done);
end.