{ obj_7.pas }
program obj_7;
uses crt,graph;

type
  Pozicio = object
     x, y    : integer;
     r_szin  : word;
     f_szin  : word;
     f_minta : word;
     constructor Init(x_koord, y_koord : integer;
                      rajzszin, festoszin, minta: word);
     destructor Done;
     procedure Rajzol; virtual;
  end;

constructor Pozicio.Init;
 begin
   x:= x_koord;
   y:= y_koord;
   r_szin:= rajzszin;
   f_szin:= festoszin;
   f_minta:= minta;
 end;

procedure Pozicio.Rajzol;
 var  Gd, Gm: integer;
 begin
   Gd:= VGA;
   Gm:= VGAHi;
   InitGraph(Gd, Gm, '');
   if GraphResult <> GrOK then Halt(1);
   SetBkColor(BLUE);
 end;

destructor Pozicio.Done;
 begin
 end;

type
  PTeglalap = ^Teglalap;
  Teglalap = object(Pozicio)
     a, b: integer;
     constructor Init(x_koord, y_koord: integer;
                      rajzszin, festoszin, minta: word;
                      a_old,b_old : integer);
     destructor Done;
     procedure Rajzol; virtual;
  end;

constructor Teglalap.Init;
 begin
   inherited Init(x_koord, y_koord,
                  rajzszin, festoszin, minta);
   a:= a_old;
   b:= b_old;
 end;

procedure Teglalap.Rajzol;
 begin
   inherited Rajzol;
   SetFillStyle(f_minta, f_szin);
   SetColor(r_szin);
   SetLineStyle(SolidLn,0,ThickWidth);
   Bar(x, y, round(a), round(b));
   Rectangle(x, y, round(a), round(b));
   readln;
 end;

destructor Teglalap.Done;
 begin
 end;

type
  PHaromszog = ^Haromszog;
  Haromszog = object(Pozicio)
     a, m: integer;
     constructor Init(x_koord, y_koord: integer;
                      rajzszin, festoszin, minta: word;
                      a_old,m_old : integer);
     destructor Done;
     procedure Rajzol; virtual;
  end;

constructor Haromszog.Init;
 begin
   inherited Init(x_koord, y_koord,
                  rajzszin, festoszin, minta);
   a:= a_old;
   m:= m_old;
 end;

destructor Haromszog.Done;
 begin
 end;

procedure Haromszog.Rajzol;
 var HSz    : array[1..4] of PointType;
 begin
   SetFillStyle(f_minta, f_szin);
   SetColor(r_szin);
   SetLineStyle(SolidLn,0,ThickWidth);
   HSz[1].X:= x;
   HSz[1].Y:= y;
   HSz[2].X:= x ;
   HSz[2].Y:= y-m;
   HSz[3].X:= x+a;
   HSz[3].Y:= y-m;
   HSz[4].X:= x;
   HSz[4].Y:= y;
   DrawPoly(4, HSz);
   FillPoly(4, HSz);
   readln;
end;

var
  Pt    : PTeglalap;
  Ph    : PHaromszog;
begin
  clrscr;
  writeln('Rajzols azonos kepernyre');
  writeln('Tglalap rajzolsa');
  new(Pt,Init(20,50,LIGHTRED,YELLOW,LineFill,50,100));
  writeln('x koordinta : ',Pt^.x:3);
  writeln('y koordinta : ',Pt^.y:3);
  writeln('a oldal      : ',Pt^.a:3);
  writeln('b oldal      : ',Pt^.b:3);
  writeln;
  writeln('Hromszog razjolsa');
  new(Ph,Init(120,120,RED,LIGHTGREEN,LineFill,50,70));
  writeln('x koordinta : ',Ph^.x:3);
  writeln('y koordinta : ',Ph^.y:3);
  writeln('alap         : ',Ph^.a:3);
  writeln('magassg     : ',Ph^.m:3);
  writeln;
  writeln('A rajzols megkezdshez');
  writeln('nyomjon <Enter>-!');
  readln;
  Pt^.Rajzol;
  Ph^.Rajzol;
  CloseGraph;
  dispose(Pt,Done);
  dispose(Ph,Done);
end.