(*-------------------------------------------------------------*
			    BIOSCOM.PAS

    A soros adatvitelt megvalst program, amely BIOS hvsokkal
    mkdik.
 *-------------------------------------------------------------*)

{$X+}
program BIOS_soros_kommunikacio;
uses crt, dos;

type
   serialport=(COM1, COM2);
   smuvelet = (PSET, SEND, RECEIVE, STATUS);

function bioscom(muvelet: smuvelet; ertek:byte; sport:serialport):word;
 var
   r : registers;
 begin
   r.ah:=ord(muvelet);
   r.al:=ertek;
   r.dx:=ord(sport);
   intr($14,r);
   bioscom:=r.ax;
 end;

const
     ESC       = $1B;
     { kommunikcis paramterek }
     BAUD_300  = $40;
     BAUD_1200 = $80;
     BAUD_9600 = $E0;

     PARITY_NONE=$00;
     PARITY_ODD =$08;
     PARITY_EVEN=$18;

     BITS_7 = $02;
     BITS_8 = $03;
     STOP_1 = $00;
     STOP_2 = $04;


{----------------------}
{ A tesztel fprogram }
{----------------------}
var
  cport : serialport;
  c : word;
  done : boolean;
  ps : string[1];

begin
  done:=false;
  if (paramcount<>1) or ((paramstr(1)<>'1') and (paramstr(1)<>'2')) then
     begin
       writeln('Hasznlat: BIOSCOM 1 | 2');
       halt;
     end;

  { A parancssor feldolgozsa: 1 - COM1, 2 - COM2) }
  ps :=paramstr(1);
  cport := serialport(ord(ps[1])-49);

  { A kommunikcis paramterek megadsa }
  bioscom(PSET, BAUD_9600 or BITS_8 or STOP_1 or PARITY_NONE, cport);

  textbackground(BLACK);
  clrscr;

  textcolor(GREEN);
  writeln('TURBO Pascal soros kommunikcis program');
  writeln('... kilps az <ESC> billentyvel ...');

  { A program fciklusa, amely a billentyzet- s a   }
  { soros portrl egyarnt feldolgozza a karaktereket }
  repeat
      { Olvass a billentyzetpufferbl }
      if keypressed then
      begin
          c:=ord(readkey);
	  case (c) of
	      ESC:  { Kilps }
                    done := true;
              13 :  { Soremels }
                    writeln;
	      else  { Echo }
                   begin
		     textcolor(GREEN);
		     write(chr(c));
                   end;
	  end;
	  { A karakter elkldse }
	  bioscom(SEND, c, cport);
      end;

      { A soros port llapotnak lekrdezse }
      c := bioscom(STATUS, 0, cport);
      { Olvass a soros portrl, ha van rvnyes adat }
      if ((c shr 8) and 1 ) = 1 then
	begin
	  c := bioscom(RECEIVE, 0, cport);
          case c of
            13 : { Soremels }
                 writeln;
            ESC: { Kilps }
                 done := true;
            else
               begin
                 textcolor(CYAN);
                 write(chr(c));
               end;
          end;
	end;
  until (done);

  textcolor(LIGHTGRAY);
  writeln;
  writeln('Viszlt!');
 end.
